<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controller');

/**
 * Controller Class
 * */
class CCKjSeblod_WebServiceControllerJobs extends CCKjSeblod_WebServiceController {

    var $_isAuth = null;
    var $_viewName = 'job';
    var $_viewNames = 'jobs';
    var $_viewTable = 'jseblod_cck_webservices_jobs';
    var $_viewTable_scheduler = 'jseblod_cck_webservices_job_scheduler';
    var $_viewTable_more = 'jseblod_cck_webservices_tasks';
    var $_viewTable_more1 = 'jseblod_cck_webservices_job_task';
    var $_viewTablemore2ws = 'jseblod_cck_webservices';
    var $_viewTablemore3tc = 'jseblod_cck_webservices_task_config';
    var $_viewTablemore4tp = 'jseblod_cck_webservices_task_process';
    var $_viewLink = _LINK_VIEW_3;

    /**
     * Constructor
     * */
    function __construct() {
        parent::__construct();

        // Register Extra Tasks
        $this->registerTask('add', 'edit');
        $this->registerTask('copy', 'edit');
        $this->registerTask('apply', 'save');
        $this->registerTask('delete', 'edit');
        $this->registerTask('process', 'process');


        // Check User Auth
        $user = & JFactory::getUser();
        $isAuth = ( $user->get('gid') < _VIEW_ACCESS ) ? 0 : 1;
        $this->_setValues($isAuth);
    }

    /**
     * Set Values
     * */
    function _setValues($isAuth) {
        // Set Values
        $this->_isAuth = $isAuth;
    }

    /**
     * Display Default View
     * */
    function display() {
        global $mainframe;

        // Check User Authorization
        if (!$this->_isAuth) {
            $mainframe->redirect(_LINK_COMPONENT, JText::_('Alertnotauth'), 'error');
        }

        switch ($this->getTask()) {
            case 'element':
                JRequest::setVar('view', $this->_viewNames);
                JRequest::setVar('layout', 'element');
                break;
            case 'select':
                JRequest::setVar('view', $this->_viewNames);
                JRequest::setVar('layout', 'select');
                break;
            default:
                // Set Default View
                $view = JRequest::getCmd('view');
                if (empty($view)) {
                    JRequest::setVar('view', $this->_viewNames);
                    JRequest::setVar('layout', 'default');
                }
                break;
        }

        parent::display();
    }

    /**
     * Display Edit Form
     * */
    function edit() {
        global $mainframe;

        // Check User Authorization;
        if (!$this->_isAuth) {
            $mainframe->redirect(_LINK_COMPONENT, JText::_('Alertnotauth'), 'error');
        }

        switch ($this->getTask()) {
            case 'add':
            case 'edit':
                JRequest::setVar('view', $this->_viewName);
                JRequest::setVar('layout', 'form');
                JRequest::setVar('hidemainmenu', 1);
                JRequest::setVar('doCopy', false);
                JRequest::setVar('doDelete', false);
                JRequest::setVar('doSource', false);
                JRequest::setVar('doProcess', false);
                break;
            case 'copy':
                JRequest::setVar('view', $this->_viewName);
                JRequest::setVar('layout', 'form');
                JRequest::setVar('hidemainmenu', 1);
                JRequest::setVar('doCopy', true);
                JRequest::setVar('doDelete', false);
                JRequest::setVar('doSource', false);
                JRequest::setVar('doProcess', false);
                break;
            case 'delete':
                JRequest::setVar('view', $this->_viewName);
                JRequest::setVar('layout', 'delete');
                JRequest::setVar('hidemainmenu', 1);
                JRequest::setVar('doCopy', false);
                JRequest::setVar('doDelete', true);
                JRequest::setVar('doSource', false);
                JRequest::setVar('doProcess', false);
                break;

            default:
                break;
        }

        parent::display();
    }

    /**
     * Remove &&  Redirect
     * */
    function remove() {

        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $deleteMode = 1;
        $model = $this->getModel($this->_viewName);
        //wv model=>job

        if ($total = $model->delete($deleteMode)) {
            $msg = JText::sprintf('Items Removed', $total);
            $msgType = 'message';
        } else {
            $msg = JText::_('An error has occurred');
            $msgType = 'error';
        }

        $link = $this->_viewLink;

        $this->setRedirect($link, $msg, $msgType);
    }

    /**
     * Remove && Redirect
     * */
    function removeAll() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $deleteMode = -1;
        $model = $this->getModel($this->_viewName);

        if ($total = $model->delete($deleteMode)) {
            $msg = JText::sprintf('Items Removed', $total);
            $msgType = 'message';
        } else {
            $msg = JText::_('An error has occurred');
            $msgType = 'error';
        }
        $link = $this->_viewLink;

        $this->setRedirect($link, $msg, $msgType);
    }

    /**
     * Publish && Redirect
     * */
    function publish() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $model = $this->getModel($this->_viewName);

        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1) {
            JError::raiseError(500, JText::_('Select an Item to publish'));
        }

        if (!$model->publish($cid, 1)) {
            echo "<script> alert('" . $model->getError(true) . "'); window.history.go(-1); </script>\n";
        }

        $link = $this->_viewLink;

        $this->setRedirect($link);
    }

    /**
     * Unpublish && Redirect
     * */
    function unpublish() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $model = $this->getModel($this->_viewName);

        $cid = JRequest::getVar('cid', array(), 'post', 'array');
        JArrayHelper::toInteger($cid);

        if (count($cid) < 1) {
            JError::raiseError(500, JText::_('Select an Item to unpublish'));
        }

        if (!$model->publish($cid, 0)) {
            echo "<script> alert('" . $model->getError(true) . "'); window.history.go(-1); </script>\n";
        }

        $link = $this->_viewLink;

        $this->setRedirect($link);
    }

    /**
     * Categories Redirection
     * */
    function categories() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $link = $this->_viewLink . '_categories';

        $this->setRedirect($link);
    }

    /**
     * Add Category Redirection
     * */
    function addcategory() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $link = $this->_viewLink . '_categories' . '&task=add';

        $this->setRedirect($link);
    }

    /**
     * Batch Category Process
     * */
    function batchCategory() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $model = $this->getModel($this->_viewName);

        if ($total = $model->batchCategory()) {
            $msg = JText::sprintf('ITEMS UPDATED', $total);
            $msgType = 'message';
        } else {
            $msg = JText::_('An error has occurred');
            $msgType = 'error';
        }

        $link = $this->_viewLink;

        $this->setRedirect($link, $msg, $msgType);
    }

    /**
     * Save && Redirect
     * execute the schedulered task(s)
     * mode=0    off
     * mode=1    one time
     * mode=100  custom
     * */
    function save() {




        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        if (!defined('JPATH_LOG')) {
            define('JPATH_LOG', JPATH_SITE . DS . logs);
        }


        $model = $this->getModel($this->_viewName);

        if ($rowId = $model->store()) {
            $msg = JText::_('Item Saved');
            $msgType = 'message';
        } else {
            $msg = JText::_('An error has occurred');
            $msgType = 'error';
        }

        // Checkin!
        $model->checkin();

        switch ($this->getTask()) {
            case 'apply':
                $link = ( $rowId ) ? $this->_viewLink . '&task=edit&cid[]=' . $rowId : $this->_viewLink;
                break;
            case 'save':
                $link = $this->_viewLink;
                break;
            default:
                break;
        }
        //$this->setRedirect( $link, $msg, $msgType );
        //schedular for job

        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod_webservice' . DS . 'tables');
        $row = & JTable::getInstance('jobs', 'Table');
        $row->load($rowId);
        $active = $row->active;
        $jobname = $row->name;

        // give the unique name for the task :
        srand((double) microtime() * 1000000);
        $randval = rand();





        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod_webservice' . DS . 'helpers' . DS . 'helper_webservice.php');
        require_once(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod_webservice' . DS . 'helpers' . DS . 'helper_runtime.php' );
        $mode = Helper_Webservice::getRunMode($rowId);
        ini_set("error_log",JPATH_LOG.DS.'error.log');
        //condition for starting the Job
        if (($mode != 0) and (!file_exists(JPATH_LOG . DS . $jobname) ) and ( $active == 0 )) {

            $row->active = 1;
            $row->store();
            ob_end_clean();
            $this->setRedirect($link, $msg, $msgType);
            //header("Location: http://seblod-dev.com/projects/packs/administrator/index.php?option=com_cckjseblod_webservice&controller=jobs/");
            header("Location: index.php?option=com_cckjseblod_webservice&controller=jobs");
            header("Connection: close");
            //header("Location: http://www.google.com/");
            ob_start();
            $size = ob_get_length();
            header("Content-Length: $size");
            ob_end_flush();
            flush();
            sleep(1);

            $run = true;
            $interval = 0;
            set_time_limit(0);
            ignore_user_abort(true);

            $dest1 = JPATH_LOG . DS . $jobname;
            $handle1 = fopen($dest1, "a");

            $dest2 = JPATH_LOG . DS . 'log.txt';
            $handle2 = fopen($dest2, "a");
            $i = 0;
            /*             * **
             * ** */
            fwrite($handle2, " $randval-->: " . "jobname = '" . $jobname . "',mode=>" . "$mode" . ",Launched time: " . date("Y-m-d H:i:s") . "\r\n");

            $time_schedular = Helper_Webservice::getSchedulerJob($rowId, $this->_viewTable_scheduler);


            fwrite($handle2, " $randval-->: " . "mode=>" . $mode . "," . "Time to wait:" . $time_schedular . "," . "jobid:$rowId,'$jobname'" . "\r\n");
            fwrite($handle2, " $randval-->: " . "------before run" . "\r\n");
            $this->setRedirect($link, $msg, $msgType);

            if ($mode == 100) {
                $execute_time = 0;
            }

            while ($run) { //mode 0=> stop the task, mode 1 => only one time.
                //
                set_time_limit(0);

                $time_schedular = Helper_Webservice::getSchedulerJob($rowId, $this->_viewTable_scheduler);
                if ($mode == 100) {
                    $time_schedular -= $execute_time;
                }

                fwrite($handle2, " $randval-->: " . "I am in run(While), mode:" . $mode . "," . "schedular_time:$time_schedular" . "--" . "jobid:=>$rowId,$jobname" . "\r\n");
                fwrite($handle2, " $randval-->: " . "I will sleep $time_schedular s" . "\r\n");
                sleep($time_schedular);

                fwrite($handle2, " $randval-->: " . "ok, I slept $time_schedular s" . "\r\n");
                $mode = Helper_Webservice::getRunMode($rowId); //maybe w
                fwrite($handle2, " $randval-->: " . "mode=>" . $mode . "rowId=>" . $rowId . "jobname=>" . $jobname . "\r\n");
                if ($mode == 0) {
                    $run = false;
                    fclose($handle1);
                    $un_link = unlink(JPATH_LOG . DS . $jobname);
                    $row->active = 0;
                    $row->mode = $mode;
                    $row->store();

                    $mode0log = JPATH_LOG . DS . 'mode0.log';
                    $hd3 = fopen($mode0log, 'a');
                    fwrite($hd3, " $randval-->: " . "un_link=" . $un_link . "File: " . JPATH_LOG . DS . $jobname . "\r\n");
                    fwrite($hd3, " $randval-->: " . $jobname . "is colsed manually: Closed time: " . date("Y-m-d H:i:s") . "\r\n");
                    fclose($hd3);
                    exit;   //
                }

                if ($mode == 1) {//run only one time
                    $run = 0;
                    $close = fclose($handle1);
                    $un_link = unlink($dest1);
                    $row->mode = $mode;
                    $row->active = 0;
                    $row->store();

                    $mode1log = JPATH_LOG . DS . 'mode1.log';
                    $hd5 = fopen($mode1log, 'a');
                    fwrite($hd5, " $randval-->: " . "I am in the run/while/mode1," . "Datetime=" . date("Y-m-d H:i:s") . "\r\n");
                    fwrite($hd5, " $randval-->: " . "The file: " . $jobname . " is deleted: " . "\r\n");
                    fwrite($hd5, " $randval-->: " . "un_link=" . $un_link . "File: " . JPATH_LOG . DS . $jobname . "\r\n");
                    fwrite($hd5, " $randval-->: " . "mode=" . $mode . "fclose=" . $close . " mode 1 Ok: " . "\r\n");
                }

                //wirte in the log file
                //date_default_timezone_set('PRC');
                //$_viewTable_more		    =	'jseblod_cck_webservices_tasks';
                //$_viewTable_more1		    =	'jseblod_cck_webservices_job_task';
                $dateTime = date("Y-m-d H:i:s");
                $tasknames = Helper_Helper::getJobTaskName($this->_viewTable_more1, $this->_viewTable_more, $rowId);
                fwrite($handle2, "$randval-->: " . "Ok, I will operate the database;");
                fwrite($handle2, " $randval-->: " . "--" . "job will be exectued:" . $i . "time(s) ->" . $jobname . ":datetime=>" . $dateTime . "--schedular:" . $time_schedular . "s" . "--jobname:" . $jobname . "--" . $starth . "--" . $startm);
                fwrite($handle2, " $randval-->: " . "--" . "\r\n");
                fwrite($handle2, " $randval-->: " . "--" . "tasks=>" . $tasknames . "--" . "mode=>" . $mode);
                fwrite($handle2, " $randval-->: " . "--" . "\r\n");
                $i++;
                fwrite($handle2, " $randval-->: " . "--" . "run=" . $run . "bbb" . "\r\n");
                // Call Task
                $runtime = new Helper_Runtime;
                fwrite($handle2, "before temp " . "\r\n");
                $runtime->start();
                fwrite($handle2, "start " . "\r\n");
                fwrite($handle2, "jobname =$jobname" . "\r\n");
                ///
                fwrite($handle2, "tasknames =$tasknames" . "\r\n");
                Helper_Webservice::callTask_Temp($jobname, $tasknames);   //
                fwrite($handle2, "ok bdd " . "\r\n");

                fwrite($hd5, "$randval-->: " . "action success:callTask_temp, Time:=" . date("Y-m-d H:i:s") . "\r\n");
                Helper_Webservice::callJob($jobname, $this->_viewTable_more1, $this->_viewTable_more, $rowId, $this->_viewTable_more, $this->_viewTablemore2ws, $this->_viewTablemore3tc, $this->_viewTablemore4tp);
                fwrite($hd5, "$randval-->: " . "action success:callTask, Time:=" . date("Y-m-d H:i:s") . "\r\n");
                fclose($hd5);
                $runtime->stop();
                $execute_time = $runtime->spent() / 1000;
                sleep(0.1);
                fwrite($handle2, "$randval-->: " . "--" . "run=" . $run . "\r\n");
                //unlink(JPATH_LOG.DS.$jobname);
            }
            exit;
        } else {
            $this->setRedirect($link, $msg, $msgType);
        }
    }

    /**
     * Live Save && Redirect
     * */
    function liveSave() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $model = $this->getModel($this->_viewName);

        if ($rowId = $model->liveStore()) {
            
        }

        $link = $this->_viewLink;

        $this->setRedirect($link);
    }

    /**
     * Cancel && Redirect
     * */
    function cancel() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $model = $this->getModel($this->_viewName);

        // Checkin!
        $model->checkin();

        $link = $this->_viewLink;

        $this->setRedirect($link);
    }

    /**
     * Back
     * */
    function back() {
        // Check for Request Forgeries
        JRequest::checkToken() or die('Invalid Token');

        $link = $this->_viewLink;

        $this->setRedirect($link);
    }

    /**
     * Check Availability [ Ajax ]
     * */
    function checkAvailability() {
        $available = 0;
        $total = 0;

        if ($available = JRequest::getVar('available', '', 'get', 'string')) {
            if ($available == 'class') {
                $total = 1;
            } else {
                $db = & JFactory::getDBO();
                $where = ' WHERE s.name = "' . $available . '"';

                $query = ' SELECT COUNT( s.id )'
                        . ' FROM #__' . $this->_viewTable . ' AS s'
                        . $where
                ;
                $db->setQuery($query);
                $total = $db->loadResult();
            }
        }

        echo $total;
    }

    /**
     * Process
     * */
    function process() {
        JRequest::setVar('view', $this->_viewNames);
        JRequest::setVar('layout', 'process');
        JRequest::setVar('doProcess', true);
        $id = JRequest::getVar('cid');
        $jobid = $id[0];
        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'tables');
        $row = & JTable::getInstance($this->_viewNames, 'Table');
        $row->load($jobid);
        $jobname = $row->title;
        JRequest::setVar('jobname', $jobname);
        JRequest::setVar('jobid', $jobid);
        parent::display();
    }

    function ajaxGetDropDownLists() {
        $val = JRequest::getVar('selected');
        //JRequest::getVar( 'selected', '', 'get', 'string' );
        //Helper_Helper::getTaskIdName
        //return JHTML::_( 'select.genericlist', $optList, 'name', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selected );
    }

    function executeSchedulerJob() {

        switch ($this->getTask()) {
            case 'apply':
                $link = ( $rowId ) ? $this->_viewLink . '&task=edit&cid[]=' . $rowId : $this->_viewLink;
                break;
            case 'runjob':
                $link = $this->_viewLink;
                break;
            default:
                break;
        }
        //$this->setRedirect( $link, $msg, $msgType );
        /* lsl */
        //schedular for job

        $req = JRequest::getVar('cid', '', 'get', 'array');
        $rowId = $req[0];
        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod_webservice' . DS . 'tables');
        $row = & JTable::getInstance('jobs', 'Table');
        $row->load($rowId);
        $active = $row->active;

        $jobname = $row->title;

        require_once(JPATH_COMPONENT_ADMINISTRATOR . DS . 'helpers' . DS . 'helper_webservice.php');
        $mode = Helper_Webservice::getRunMode($rowId);

        if (($mode != 0) and (!file_exists(JPATH_LOG . DS . $jobname)) and ($active == 0)) {

            $row->active = 1;
            $row->store();
            ob_end_clean();
            $this->setRedirect($link, $msg, $msgType);
            header("Connection: close");
            ob_start();
            $size = ob_get_length();
            header("Content-Length: $size");
            ob_end_flush();
            flush();
            sleep(1);

            $run = true;
            $interval = 0;
            set_time_limit(0);
            ignore_user_abort(true);

            $dest1 = JPATH_LOG . DS . $jobname;
            $handle1 = fopen($dest1, "w");
            $dest2 = JPATH_LOG . DS . 'log.txt';
            $handle2 = fopen($dest2, "a");
            $i = 0;
            $this->setRedirect($link, $msg, $msgType);

            while ($run) { //mode 0=> stop the task, mode 1 => only one time.
                //
                $time_schedular = Helper_Webservice::getSchedulerJob($rowId, $this->_viewTable_scheduler);
                sleep($time_schedular);
                $mode = Helper_Webservice::getRunMode($rowId);
                if ($mode == 0) {
                    $run = false;
                    fclose($handle1);
                    unlink(JPATH_LOG . DS . $jobname);
                    $row->active = 0;
                    $row->mode = $mode;
                    $row->store();
                    exit;
                }

                if ($mode == 1) {//run only one time
                    $run = false;
                    fclose($handle1);
                    unlink(JPATH_LOG . DS . $jobname);
                    $row->mode = $mode;
                    $row->active = 0;
                    $row->store();
                }

                //wirte in the log file
                date_default_timezone_set('PRC');
                $dateTime = date("Y-m-d H:i:s");
                $tasknames = Helper_Helper::getJobTaskName($this->_viewTable_more1, $this->_viewTable_more, $rowId);

                fwrite($handle2, "--" . $i . "->" . $jobname . ":" . $dateTime . "--" . $time_schedular . "s" . "--" . $jobname . "--" . $starth . "--" . $startm);
                fwrite($handle2, "--" . "\r\n");
                fwrite($handle2, "--" . "tasks=>" . $tasknames);
                fwrite($handle2, "--" . "\r\n");
                $i++;

                // Call Task
                //Helper_Webservice::callTask_Temp($jobname);
                Helper_Webservice::callJob($jobname, $this->_viewTable_more1, $this->_viewTable_more, $rowId, $this->_viewTable_more, $this->_viewTablemore2ws, $this->_viewTablemore3tc, $this->_viewTablemore4tp);

                sleep(0.1);
            }
            exit;
        } else {
            $this->setRedirect($link);
        }
    }

}

?>