<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

/**
 * Controller Class
 **/
class CCKjSeblod_WebServiceControllerTasks extends CCKjSeblod_WebServiceController
{
	var $_isAuth	=	null;
	var $_viewName	=	'task';
	var $_viewNames	=	'tasks';
	var $_viewTable	=	'jseblod_cck_webservices_tasks';
		
	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();
		
		// Register Extra Tasks
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'copy', 'edit' );
		$this->registerTask( 'apply', 'save' );
		$this->registerTask( 'delete', 'edit' );
		$this->registerTask( 'process', 'edit' );
		
		// Check User Auth
		$user 	=&	JFactory::getUser();
		$isAuth	=	( $user->get( 'gid' ) < _VIEW_ACCESS ) ? 0 : 1;
		$this->_setValues( $isAuth );
	}
	
	/**
	 * Set Values 
	 **/
	function _setValues( $isAuth )
	{
		// Set Values
		$this->_isAuth	= $isAuth;
	}
	
	/**
	 * Display Default View
	 **/
	function display()
	{
		global $mainframe;
		
		// Check User Authorization
		if ( ! $this->_isAuth ) {
			$mainframe->redirect( _LINK_COMPONENT, JText::_( 'Alertnotauth' ), 'error' );
		}
		
		switch( $this->getTask() ) {
			case 'element':
				JRequest::setVar( 'view', $this->_viewNames );
				JRequest::setVar( 'layout', 'element' );
				break;
			case 'select':
				JRequest::setVar( 'view', $this->_viewNames );
				JRequest::setVar( 'layout', 'select' );
				break;
			default:
				// Set Default View
				$view	=	JRequest::getCmd( 'view' );
				if ( empty( $view ) ) {
					JRequest::setVar( 'view', $this->_viewNames );
					JRequest::setVar( 'layout', 'default' );
				}
				break;
		}
			
		parent::display();
	}
	
	/**
	 * Display Edit Form
	 **/
	function edit()
	{
		global $mainframe;
		
		// Check User Authorization;
		if ( ! $this->_isAuth ) {
			$mainframe->redirect( _LINK_COMPONENT, JText::_( 'Alertnotauth' ), 'error' );
		}
		
		switch( $this->getTask() ) {
			case 'add':
			case 'edit':
				JRequest::setVar( 'view', $this->_viewName );
				JRequest::setVar( 'layout', 'form' );
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'doCopy', false );
				JRequest::setVar( 'doDelete', false );
				JRequest::setVar( 'doProcess', false );
				break;
			case 'copy':
				JRequest::setVar( 'view', $this->_viewName );
				JRequest::setVar( 'layout', 'form' );
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'doCopy', true );
				JRequest::setVar( 'doDelete', false );
				JRequest::setVar( 'doProcess', false );
				break;
			case 'delete':
				JRequest::setVar( 'view', $this->_viewName );
				JRequest::setVar( 'layout', 'delete' );
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'doCopy', false );
				JRequest::setVar( 'doDelete', true );
				JRequest::setVar( 'doProcess', false );
				break;
			case 'process':
				JRequest::setVar( 'view', $this->_viewName );
				JRequest::setVar( 'layout', 'process' );
				JRequest::setVar( 'hidemainmenu', 1 );
				JRequest::setVar( 'doCopy', false );
				JRequest::setVar( 'doDelete', false );
				JRequest::setVar( 'doProcess', true );
				break;
			default:
				break;
		}
		
		parent::display();
	}
	
	/**
	 * Remove &&  Redirect
	 **/
	function remove()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$model	=	$this->getModel( $this->_viewName );
		
		if ( $total = $model->delete() ) {
			$msg		=	JText::sprintf( 'Items Removed', $total );
			$msgType	=	'message';
		} else {
			$msg		=	JText::_( 'An error has occurred' );
			$msgType	=	'error';
		}
		
		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link, $msg, $msgType );
	}

	/**
	 * Publish && Redirect
	 **/
	function publish()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$model	=	$this->getModel( $this->_viewName );
		
		$cid	=	JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger( $cid );

		if ( count( $cid ) < 1 ) {
			JError::raiseError( 500, JText::_( 'Select an Item to publish' ) );
		}

		if ( ! $model->publish( $cid, 1 ) ) {
			echo "<script> alert('".$model->getError(true)."'); window.history.go(-1); </script>\n";
		}

		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link );
	}
	
	/**
	 * Unpublish && Redirect
	 **/
	function unpublish()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$model	=	$this->getModel( $this->_viewName );

		$cid	=	JRequest::getVar( 'cid', array(), 'post', 'array' );
		JArrayHelper::toInteger( $cid );

		if ( count( $cid ) < 1 ) {
			JError::raiseError( 500, JText::_( 'Select an Item to unpublish' ) );
		}

		if( ! $model->publish( $cid, 0 ) ) {
			echo "<script> alert('".$model->getError( true )."'); window.history.go(-1); </script>\n";
		}

		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link );
	}
		
	/**
	 * Categories Redirection
	 **/
	function categories()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$link	=	_LINK_VIEW_2.'_categories';
		
		$this->setRedirect( $link );
	}
	
	/**
	 * Add Category Redirection
	 **/
	function addcategory()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$link	=	_LINK_VIEW_2.'_categories'.'&task=add';
		
		$this->setRedirect( $link );
	}
	
	/**
	 * Batch Category Process
	 **/
	function batchCategory()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
				
		$model	=	$this->getModel( $this->_viewName );

		if ( $total = $model->batchCategory() ) {
			$msg		=	JText::sprintf( 'ITEMS UPDATED', $total );
			$msgType	=	'message';
		} else {
			$msg		=	JText::_( 'An error has occurred' );
			$msgType	=	'error';
		}
		
		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link, $msg, $msgType );
	}
	
	/**
	 * Save && Redirect
	 **/
	function save()
	{
		// Check for Request Forgeries
		
		JRequest::checkToken() or die( 'Invalid Token' );
                $flag = 1;  //yes or not to save in the db
                $data_post = JRequest::get('post');
                /////find the access's type
                $accessname = $data_post['webservice'];
                $query = "SELECT type FROM #__jseblod_cck_webservices WHERE name = '".$accessname."'";
                $accesstype = CCK_DB_Result($query);
                
		$model	=	$this->getModel( $this->_viewName );
                ///add conditon, or another task doesn't work
               
                $exp_cat    = $data_post['attributes']['expcat'];
                $exp_ct     = $data_post['attributes']['exp_content_type'];
                if( $accesstype == 5 && $exp_cat =='' && $exp_ct =='' ){ ///joomla database
                    $msg 		=	JText::_( 'AN ERROR HAS OCCURRED 8' );
		    $msgType            =	'error';
                    $flag               = 0;
                }
                
                /// flag for export the articles
                if($flag == 1) {
                    if ( $rowId = $model->store() ) {
                            $msg		=	JText::_( 'Item Saved' );
                            $msgType	=	'message';
                            
                    } else {
                            $msg 		=	JText::_( 'An error has occurred' );
                            $msgType	=	'error';
                    }
                }
                ///
		// Checkin!
		$model->checkin();
		
		switch( $this->getTask() ) {
			case 'apply':
				$link	=	( $rowId ) ? _LINK_VIEW_2.'&task=edit&cid[]='.$rowId : _LINK_VIEW_2;
				break;
			case 'save':
				$link	=	_LINK_VIEW_2;
				break;
			default:
				break;
		}
		
		$this->setRedirect( $link, $msg, $msgType );
		
		
	}
	
	/**
	 * Live Save && Redirect
	 **/
	function liveSave()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$model	=	$this->getModel( $this->_viewName );
		
		if ( $rowId = $model->liveStore() ) {
		}
		
		$link = _LINK_VIEW_2;
		
		$this->setRedirect( $link );
	}
	
	/**
	 * Cancel && Redirect
	 **/ 
	function cancel()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$model	=	$this->getModel( $this->_viewName );
		
		// Checkin!
		$model->checkin();
		
		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link );
	}
		
	/**
	 * Back
	 **/
	function back()
	{
		// Check for Request Forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		
		$link	=	_LINK_VIEW_2;
		
		$this->setRedirect( $link );
	}
	
	/**
	 * Check Availability [ Ajax ]
	 **/
	function checkAvailability()
	{
		$available	=	0;
		$total		=	0;
		
		if ( $available = JRequest::getVar( 'available', '', 'get', 'string' ) ) {
			if ( $available == 'class' ) {
				$total	=	1;
			} else {
				$db		=&	JFactory::getDBO();
				$where 	=	' WHERE s.name = "'.$available.'"';
				
				$query = ' SELECT COUNT( s.id )'
					   . ' FROM #__'.$this->_viewTable.' AS s'
					   . $where
					   ;
				$db->setQuery( $query );
				$total	=	$db->loadResult();
			}
		} 
		
		echo $total;
	}
	
	/**
	 * Get Functions [ Ajax ]
	 **/
	function ajaxGetFunctions()
	{
		$display	=	null;
		$filename	=	JRequest::getVar( 'selected', '', 'get', 'string' );
	 	$model		=	$this->getModel( $this->_viewName );
			
		if ( $filename ) {
			$display 	=	 $model->ajaxGetFunctions( $filename, '' );
		} else {
			$display	=	JText::_( 'SELECT A WEBSERVICE FIRST' );
		}
		
		echo $display;
	}
	
	/**
	 * Get Params [ Ajax ]
	 **/
	function ajaxGetParams()
	{
		$display	=	null;
		$filename	=	JRequest::getVar( 'selected', '', 'get', 'string' );
		$function	=	JRequest::getVar( 'selected2', '', 'get', 'string' );
		$taskid		=	JRequest::getVar( 'selected3', '', 'get', 'int' );
		$model		=	$this->getModel( $this->_viewName );
		
		if ( $filename && $function ) {
			$display 	=	 $model->ajaxGetParams( $filename, $function, $taskid );
		} else {
			$display	=	'<i>' . JText::_( 'SELECT A FUNCTION FIRST' ) . '</i>';
		}
		
		echo $display;
	}
	
	//return webservice's type (all)
  function  ajaxGetWebservice(){
  
	  //$type   =  null;
	  $wsname =  JRequest::getVar( 'ws', '', 'get', 'string' );
  	$model  =  $this->getModel ( $this->_viewName ); 
    $ws	=	 $model->ajaxGetWsByName( $wsname );
  	          
    echo $ws;
	}

}

?>