<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

class Helper_FetchUrlContent {
	
	/**
	 * byCurl
	 **/
	function byCurl( $url )
	{
		$data	=	'';
		
		if ( function_exists( 'curl_init' ) ) {
			$c	=	curl_init();
			
			curl_setopt( $c, CURLOPT_URL, $url );
			curl_setopt( $c, CURLOPT_HEADER, 0 );
			curl_setopt( $c, CURLOPT_RETURNTRANSFER, 1 );
			curl_setopt( $c, CURLOPT_USERAGENT, 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.7.5) Gecko/20041107 Firefox/1.0' );
			
			$data	=	curl_exec( $c );
			curl_close( $c );
		}
		
		return $data;
	}
	
	/**
	 * byFile_get_contents
	 **/
	function byFile_get_contents( $url )
	{
		$data	=	'';
		
		if ( ini_get( 'allow_url_fopen' ) == '1' ) {
			$data	=	file_get_contents( $url );
		}
		
		return $data;
	}
	
	/**
	 * byFopen
	 **/
	function byFopen( $url )
	{
		$data	=	'';
		
		if ( ini_get( 'allow_url_fopen' ) == '1' ) {
			if ( $f = fopen( $url, 'r' ) ) {
				while ( $line = fread( $f, 1024 ) ) {
					$data	.=	$line;
				}
			}
			fclose( $f );
		}
		
		return $data;
	}
	
	/**
	 * byFsockopen
	 **/
	function byFsockopen( $url )
	{
		$data	=	'';
		
		$parsedUrl	=	parse_url( $url );
		$host		=	$parsedUrl['host'];
		$path		=	( isset( $parsedUrl['path'] ) ) ? $parsedUrl['path'] : '/';
		$path		.=	( isset( $parsedUrl['query'] ) ) ? '?'.$parsedUrl['query'] : '';
		$port		=	( isset($parsedUrl['port'] ) ) ? $parsedUrl['port'] : '80';
		$time		=	10;
		
		$f	=	@fsockopen( $host, $port, $errno, $errstr, $time );
		if ( $f ) {
			fputs( $f, "GET $path HTTP/1.0\r\n"
					.	"Host: $host\r\n"
					.	"User-Agent: Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.0.3) Gecko/20060426 Firefox/1.5.0.3\r\n"
					.	"Accept: */*\r\n"
					.	"Accept-Language: en-us,en;q=0.5\r\n"
					.	"Accept-Charset: ISO-8859-1,utf-8;q=0.7,*;q=0.7\r\n"
					.	"Keep-Alive: 300\r\n"
					.	"Connection: keep-alive\r\n"
					.	"Referer: http://$host\r\n\r\n" );
			while ( $line = fread( $f, 4096 ) ) { 
				$data .= $line;
			}
			fclose( $f );
			$data	=	substr( $data, strpos( $data, "\r\n\r\n" ) + 4 );
		}
		
		return $data;
	}
	
}

?>