<?php
/**
* @version			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined('_JEXEC') or die('Restricted access');

/**
 * Display Class
 **/
class Helper_Display
{	
	/**
     * Quick Icon Button
     **/
	function quickiconButton( $link, $image, $text, $add_text )
	{
		global $mainframe;
		$lang		=& JFactory::getLanguage();
		$template	= $mainframe->getTemplate();
		$rel 		= "{handler: 'iframe', size: {x: "._MODAL_WIDTH.", y: 320}}";
		?>
		<div style="float:<?php echo ( $lang->isRTL() ) ? 'right' : 'left'; ?>;  width: 108px; margin-right: 7px; margin-bottom: 5px;">
			<div class="icon">
				<a href="<?php echo $link; ?>">
					<?php echo JHTML::_( 'image.site',  $image, '/components/com_cckjseblod_webservice/assets/images/48/', NULL, NULL, $text ); ?>
					<span><?php echo $text; ?></span></a>
			</div>
		</div>
		<?php
	}
	
	/**
     * Help
     **/
	function help( $ref )
	{
		$bar		=&	JToolBar::getInstance( 'toolbar' );
		$lang		=&	JFactory::getLanguage();
		$lang_tag	=	$lang->getTag();
		
		if ( ! ( $lang_tag == 'en-GB' || $lang_tag == 'fr-FR' || $lang_tag == 'de-DE' ) ) {
			$lang_tag = 'en-GB';
		}
		$link	=	'http://www.jseblod.com/jseblod_help/cck/'.$lang_tag.'/'.$ref.'.php';
		
		$bar->appendButton( 'Popup', 'helpjseblod', 'Help', $link, _MODAL_WIDTH, _MODAL_HEIGHT );
	}
	
	/**
     * Quick Copyright
     **/
	function quickCopyright()
	{
		?>
		<div class="copyright">
  			<?php echo '<strong>'.JText::_( 'Tasks & WebServices' ).' '._VERSION.'</strong>'; ?>
			<br /><a target="_blank" href="http://www.seblod.com"><?php echo 'Add-on for SEBLOD 1.x'; ?></a>
            <?php echo '<strong>'.' &copy 2011</strong>'; ?>
		</div>
		<?php
	}
	
	/**
     * Quick Legend
     **/
	function quickLegend()
	{
		?>
		<div style="float: left">
			<?php echo '<font color="gray">(*)&nbsp;' . JText::_( 'EXACT' ) . '</font>'; ?>		
		</div>
		<?php
	}
	
	/**
	 * Quick Modal Task
     **/
	function quickModalTask( $text, $from, $into, $class, $controller, $task, $width = _MODAL_WIDTH, $height = _MODAL_HEIGHT, $extra = '' )
	{
		global $option;
	
		$from	=	( $from ) ? '&amp;from=' . $from : null;
		$into	=	( $into ) ? '&amp;into=' . $into : null;
		$extra	=	( $extra ) ? '&amp;'.$extra : null;
		
		$link 	= 	'index.php?option='.$option.'&amp;controller='.$controller.'&amp;task='.$task.'&amp;tmpl=component'.$from.$into.$extra;
		$modal	= 	"<div class=\"button2-left\"><div class=\"$class\"><a class=\"modal\" title=\"".JText::_( $text )."\" href=\"$link\" rel=\"{handler: 'iframe', size: {x: $width, y: $height}}\">"
				.	JText::_( $text )."</a></div></div>\n";
		
		return  $modal;
	}
	
	/**
     * Quick Refresh Page
     **/
	function quickRefreshPage()
	{
		?>
		<a href="javascript: this.location.reload();"><img src="components/com_cckjseblod/assets/images/icon-18-refresh.gif" border="0" /></a>
		<?php
	}
	
	/**
     * Quick Slide To
     **/
	function quickSlideTo( $direction, $text = null )
	{
		$direction	=	'#' . $direction;
		$text		=	( $text ) ? $text : JText::_( 'Num' );
		?>
		<a href="<?php echo $direction; ?>" style="color: #666666; text-decoration: none;">&nbsp;<?php echo $text; ?>&nbsp;</a>
		<?php
	}
	
	/**
	 * Quick Toolbar
     **/
	function quickToolbar( $buttons )
	{ 	?>
		<div id="toolbar" class="toolbar">
		<table class="toolbar">
			<tr>
				<?php
				
				foreach( $buttons AS $item ) {
			
				
				if ( $item[1] == 'spacer' ) { ?>
					<td class="spacer"> </td>
				<?php } else if ( $item[1] == 'divider' ) { ?>
					<td class="divider"> </td>
				<?php } else { ?>
					<td id="toolbar-<?php echo $item[1]; ?>" class="button"> <?php
					if ( $item[3] == 'ajaxtip' ) { ?>
						<a class="toolbar" href="#">
							<span class="icon-32-<?php echo $item[1]; ?> ajaxTip" title="<?php echo $item[2]; ?>"></span>
							<?php echo JText::_( $item[0] ); ?>
						</a>
					<?php } else if ( $item[3] == 'id' ) { ?>
						<a class="toolbar" href="#" id="<?php echo $item[2]; ?>">
							<span class="icon-32-<?php echo $item[1]; ?>" title="<?php echo $item[0]; ?>"></span>
							<?php echo JText::_( $item[0] ); ?>
						</a>
					<?php } else if ( $item[3] == 'onclick' ) { ?>
						<a class="toolbar" href="#" onclick="<?php echo $item[2]; ?>">
							<span class="icon-32-<?php echo $item[1]; ?>" title="<?php echo $item[0]; ?>"></span>
							<?php echo JText::_( $item[0] ); ?>
						</a>
					<?php } else { ?>
						<a class="toolbar" href="<?php echo $item[2]; ?>" target="_self">
							<span class="icon-32-<?php echo $item[1]; ?>" title="<?php echo $item[0]; ?>"></span>
							<?php echo JText::_( $item[0] ); ?>
						</a>
				<?php } ?>
					</td>
				<?php } } ?>
			</tr>
		</table>
	</div>
	<?php }
	
	/**
	 * Quick Tooltip Ajax
     **/
	function quickTooltipAjax( $text, $from, $into, $cid )
	{
		global $option;
		
		$from		=	( $from ) ? '&amp;from=' . $from : null;
		$into		=	( $into ) ? '&amp;into=' . $into : null;
		$cid		=	( $cid ) ? '&amp;cid[]=' . $cid : null;
		$text		=	( $text ) ? '&amp;legend=' . $text : null;
		
		$link 		= 	'AJAX:index.php?option='.$option.'&amp;controller=modal_tooltip'.$cid.'&amp;tmpl=component'.$from.$into.$text;
		$tooltip	= 	"<span class=\"ajaxTip\" title=\"$link\">"._IMG_BALLOON_LEFT."</span>";
		
		return  $tooltip;
	}
	
	/**
	 * Quick Tooltip Ajax Link
     **/
	function quickTooltipAjaxLink( $text, $from, $into, $cid )
	{
		global $option;
		
		$from	=	( $from ) ? '&amp;from=' . $from : null;
		$into	=	( $into ) ? '&amp;into=' . $into : null;
		$cid	=	( $cid ) ? '&amp;cid[]=' . $cid : null;
		$text	=	( $text ) ? '&amp;legend=' . $text : null;
		
		$link 	= 	'AJAX:index.php?option='.$option.'&amp;controller=modal_tooltip'.$cid.'&amp;tmpl=component'.$from.$into.$text;
		
		return  $link;
	}
	
	/**
	 * Quick Modal Wysiwyg
     **/
	function quickModalWysiwyg( $text, $from, $into, $class, $required, $cid, $mode, $width = _MODAL_WIDTH, $height = _MODAL_HEIGHT )
	{
		global $option;
		
		if ( $cid == -1 ) {
			$hidden	=	'<input type="hidden" id="'.$into.'_updated" name="'.$into.'_updated" value="1" />';
		} else {
			$hidden	=	'<input type="hidden" id="'.$into.'" name="'.$into.'" value="" />'
					.   '<input type="hidden" id="'.$into.'_updated" name="'.$into.'_updated" value="0" />';
		}
		
		$from	=	( $from ) ? '&amp;from=' . $from : null;
		$name	=	$into.'_required';
		$into	=	( $into ) ? '&amp;into=' . $into : null;
		$cid	=	( $cid ) ? '&amp;cid[]=' . $cid : null;
		$mode	=	( $mode ) ? '&amp;e_editor='.$mode : null;
		
		if ( $required ) {
			$value		=	( $required == 2 ) ? ' ' : '';
			$required	=	"<input id=\"$name\" name=\"$name\" class=\"required required-enabled\" type=\"text\" size=\"1\" maxlength=\"0\" style=\"width: 8px; height: 8px; text-align: 	
							center; cursor: default; margin-top: 5px; vertical-align: top;\" disabled=\"disabled\" value=\"$value\" />&nbsp;";
		} else {
			$required	=	'';
		}
		
		$link 	= 	'index.php?option='.$option.'&amp;controller=modal_wysiwyg'.$cid.'&amp;tmpl=component'.$from.$into.$mode;
		$modal	= 	"<div class=\"button2-left\"><div class=\"$class\"><a class=\"modal\" title=\"\" href=\"$link\" rel=\"{handler: 'iframe', size: {x: $width, y: $height}}\">".$required
				.	JText::_( $text )."</a></div></div>\n";
		$modal	=	$hidden . $modal;
		
		return  $modal;
	}
	
	/**
	 * Quick Exec Task
     **/
	function quickExecTack( $id )
	{
		$bar	=&	JToolBar::getInstance( 'toolbar' );
		
		$link	=	JRoute::_( 'index.php?option=com_cckjseblod_webservice&controller=tasks&task=process&cid='.$id.'&tmpl=component' );
		
		$bar->appendButton( 'Popup', 'tasks_process', 'PROCESS', $link, _MODAL_WIDTH, _MODAL_HEIGHT );
	}
}
?>