<?php
/**
* @version			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * Helper Class
 **/
class Helper_Helper
{
	/**
     * Get Elem List
     **/
	function getElemList( $table, $text, $value, $published = 1 )
	{
		$db	=&	JFactory::getDBO();
		
		$orderby	=	' ORDER BY s.'.$text;	
		if ( $published ) {
			$where	=	' WHERE s.published = 1';
		}
		
		$query	= 'SELECT s.'.$text.' AS text, s.'.$value.'  AS value, s.type AS type'
				. ' FROM #__'.$table.' AS s'
				. $where
				. $orderby
				;
		
		$db->setQuery( $query );
		$list	=	$db->loadObjectList();
		
		if ( ! sizeof( $list ) ) {
			$list	=	array();
		}

		return $list;
	}
	
	/**
     * Get View Categories
     **/
	function getViewCategories( $table, $excluded, $published )
	{
		$db	=&	JFactory::getDBO();
		
		$n			=	( $excluded ) ? 2 : 1;
		$orderby	=	' GROUP BY s.title ORDER BY s.lft';	
		$where		=	( $excluded ) ? ' WHERE s.lft > 1 AND s.lft BETWEEN parent.lft AND parent.rgt' : ' WHERE s.lft > 0 AND s.lft BETWEEN parent.lft AND parent.rgt';
		$where		=	( $published ) ? $where . ' AND s.published = 1' : $where;
		
		$query	= 'SELECT CONCAT( REPEAT("&nbsp;&nbsp;&nbsp;&nbsp;", COUNT(parent.title) - '.$n.'), s.title) AS text, s.id AS value'
				. ' FROM #__'.$table.' AS s, #__'.$table.' AS parent'
				. $where
				. $orderby
				;
		
		$db->setQuery( $query );
		$categories	=	$db->loadObjectList();
		
		if ( sizeof( $categories ) ) {
			$categories[0]->text	=	( ! $excluded ) ? JText::_( $categories[0]->text ) : $categories[0]->text;
		} else {
			$categories	=	array();
		}

		return $categories;
	}
	
	/**
	 * Get Wysiwyg Content
	 **/
	function getWysiwygContent( $field, $table, $itemId )
	{
		$db		=& JFactory::getDBO();
		
		$where	= ' WHERE s.id = '.$itemId;
		
  		$query 	= ' SELECT s.'.$field
				. ' FROM #__jseblod_cck_webservices_'.$table.' AS s'
				. $where
				;
    	$db->setQuery( $query );
  		$wysiwygContent	=	$db->loadResult();
		
		return $wysiwygContent;
	}
	
	/**
	 * Generates a HTML check box or boxes
     * @param array An array of objects
     * @param string The value of the HTML name attribute
     * @param string Additional HTML attributes for the <select> tag
     * @param mixed The key that is selected. Can be array of keys or just one key
     * @param string The name of the object variable for the option value
     * @param string The name of the object variable for the option text
     * @returns string HTML for the select list
     **/
	function checkBoxList( $arr, $tag_name, $tag_attribs, $key = 'value', $text = 'text', $selected = null, $idtag = false, $orientation = false )
	{
		reset( $arr );
		$html	=	"";
		for ( $i = 0, $n = count( $arr ); $i < $n; $i++ ) {
			$k	=	$arr[$i]->$key;
			$t	=	$arr[$i]->$text;
			$id	=	@$arr[$i]->id;
			
			$id_text = $tag_name;
		  if ( $idtag ) {
			 $id_text = $idtag;
		  }
			
			$extra	=	'';
			$extra	.=	$id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if ( is_array( $selected ) ) {
				foreach ( $selected as $obj ) {
					$k2	=	$obj;
					if ( $k == $k2 ) {
						$extra	.=	" checked ";
						break;
					}
				}
			} else {
				$extra	.=	($k == $selected ? " checked " : '');
			}
			// Images!!
			$count	=	strlen( $t );
			if ( $t[0] == '#' && $t[$count-1] == '#' ) {
				$t	=	substr( $t, 1, $count-2 );
				$t	=	'<img src="'.JURI::root().$t.'" alt="cancel" />';
			}
			// !!
			$html	.=	"\n\t<input type=\"checkbox\" name=\"$tag_name\" id=\"$id_text$k\" value=\"".$k."\"$extra $tag_attribs />";
			$html	.= "\n\t<label for=\"$id_text$k\">$t</label>";
			if ( $orientation == true ) {
				$html	.= "<br />";
			}
			
		}
		$html	.=	"\n";
		
		return $html;
	}
	
	/**
	* Generates an HTML radio list
	*
	* @param array An array of objects
	* @param string The value of the HTML name attribute
	* @param string Additional HTML attributes for the <select> tag
	* @param mixed The key that is selected
	* @param string The name of the object variable for the option value
	* @param string The name of the object variable for the option text
	* @returns string HTML for the select list
	*/
	function radiolist( $arr, $name, $attribs = null, $key = 'value', $text = 'text', $selected = null, $idtag = false, $orientation = false, $translate = false )
	{
		reset( $arr );
		$html	=	'';

		if (is_array($attribs)) {
			$attribs	=	JArrayHelper::toString($attribs);
		 }
		$id_text = $name;
		if ( $idtag ) {
			$id_text	=$idtag;
		}

		for ($i = 0, $n = count( $arr ); $i < $n; $i++ )
		{
			$k	=	$arr[$i]->$key;
			$t	=	$translate ? JText::_( $arr[$i]->$text ) : $arr[$i]->$text;
			$id	=	( isset($arr[$i]->id) ? @$arr[$i]->id : null);

			$extra	=	'';
			$extra	.=	$id ? " id=\"" . $arr[$i]->id . "\"" : '';
			if ( is_array( $selected ) )
			{
				foreach ( $selected as $val )
				{
					$k2	=	is_object( $val ) ? $val->$key : $val;
					if ( $k == $k2 )
					{
						$extra	.=	" selected=\"selected\"";
						break;
					}
				}
			} else {
				$extra	.=	((string)$k == (string)$selected ? " checked=\"checked\"" : '');
			}
			// Images!!
			$count	=	strlen( $t );
			if ( $t[0] == '#' && $t[$count-1] == '#' ) {
				$t	=	substr( $t, 1, $count-2 );
				$t	=	'<img src="'.JURI::root().$t.'" alt="cancel" />';
			}
			// !!
			$html	.=	"\n\t<input type=\"radio\" name=\"$name\" id=\"$id_text$k\" value=\"".$k."\"$extra $attribs />";
			$html	.=	"\n\t<label for=\"$id_text$k\">$t</label>";
			if ( $orientation == true ) {
				$html	.=	"<br />";
			}
		}
		$html	.=	"\n";
		
		return $html;
	}
	
	/**
	 * String URL Safe
	 **/
	function stringURLSafe( $string )
	{
		//remove any '-' from the string they will be used as concatonater
		$str	=	str_replace('_', ' ', $string);

		$lang	=&	JFactory::getLanguage();
		$str	=	$lang->transliterate($str);

		// remove any duplicate whitespace, and ensure all characters are alphanumeric
		$str	=	preg_replace( array( '/\s+/','/[^A-Za-z0-9_]/' ), array( '_', '' ), $str );

		// lowercase and trim
		$str	=	trim( strtolower( $str ) );
		return $str;
	}
	
	
	function getTaskIdName ( $table ) {
		$query = 'SELECT s.id, s.name , s.title FROM #__'.$table.' AS s  WHERE s.published = 1'; 
		$res = CCK_DB_ObjectList( $query );
		$taskidnames = array();
		foreach ($res as $re){
			$taskidnames[$re->id] = $re->title;
		}
		return $taskidnames;
		
	}
	
	function getTaskIdNameList ( $table ){
		
	}
	
	function getJobTaskName ( $table1, $table2, $id  ) {
		$query = 'SELECT t.title FROM #__'.$table1.' AS s '
				.' LEFT JOIN #__'.$table2 .' AS t ON s.taskid = t.id WHERE s.jobid = '.$id
				;
		$res = CCK_DB_ObjectList( $query );
		$arr = array();
		
		foreach($res as $re){
			array_push( $arr, $re->title );
		}
		$tasknames = implode(',', $arr);
		return $tasknames;
		
	}
	
	
	
	
	
}
?>