<?php
/**
 * @version		$Id: install.php 24 2009-03-31 04:07:57Z eddieajau $
 * @package		JXtended.Reports
 * @copyright	Copyright (C) 2008 - 2009 JXtended LLC. All rights reserved.
 * @license		GNU General Public License
 */

// No Direct Access
defined('_JEXEC') or die('Restricted access');

define( '_MY_COMPONENT', 'com_cckjseblod_webservice' );
define( '_MY_COMPONENT_NAME', 'cckjseblod_webservice' );
define( '_MY_COMPONENT_TITLE', 'Tasks & WebServices for SEBLOD 1.x' );

// load the component language file
$language = &JFactory::getLanguage();
$language->load( _MY_COMPONENT );

//$nPaths = $this->_paths;
$status = new JObject();
$status->modules	=	array();
$status->plugins	=	array();
$status->templates	=	array();

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * MODULE INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$modules = &$this->manifest->getElementByPath('modules');
if (is_a($modules, 'JSimpleXMLElement') && count($modules->children())) {

	foreach ($modules->children() as $module)
	{
		$mname		= $module->attributes('module');
		$mclient	= JApplicationHelper::getClientInfo($module->attributes('client'), true);

		// Set the installation path
		if (!empty ($mname)) {
			$this->parent->setPath('extension_root', $mclient->path.DS.'modules'.DS.$mname);
		} else {
			$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('No module file specified'));
			return false;
		}

		/*
		 * If the module directory already exists, then we will assume that the
		 * module is already installed or another module is using that directory.
		 */
		if (file_exists($this->parent->getPath('extension_root'))&&!$this->parent->getOverwrite()) {
			$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('Another module is already using directory').': "'.$this->parent->getPath('extension_root').'"');
			return false;
		}

		// If the module directory does not exist, lets create it
		$created = false;
		if (!file_exists($this->parent->getPath('extension_root'))) {
			if (!$created = JFolder::create($this->parent->getPath('extension_root'))) {
				$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('Failed to create directory').': "'.$this->parent->getPath('extension_root').'"');
				return false;
			}
		}

		/*
		 * Since we created the module directory and will want to remove it if
		 * we have to roll back the installation, lets add it to the
		 * installation step stack
		 */
		if ($created) {
			$this->parent->pushStep(array ('type' => 'folder', 'path' => $this->parent->getPath('extension_root')));
		}

		// Copy all necessary files
		$element = &$module->getElementByPath('files');
		if ($this->parent->parseFiles($element, -1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy language files
		$element = &$module->getElementByPath('languages');
		if ($this->parent->parseLanguages($element, $mclient->id) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy media files
		$element = &$module->getElementByPath('media');
		if ($this->parent->parseMedia($element, $mclient->id) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		$mtitle		= $module->attributes('title');
		$mposition	= $module->attributes('position');
		$mordering	= $module->attributes('ordering');
		$mstate		= $module->attributes('state');
		$mreplace	= $module->attributes('replace');

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO();

		// Check to see if a plugin by the same name is already installed
		$query = 'SELECT `id`' .
				' FROM `#__modules`' .
				' WHERE module = '.$db->Quote($mname);
		$db->setQuery($query);
		if (!$db->Query()) {
			// Install failed, roll back changes
			$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.$db->stderr(true));
			return false;
		}
		$id = $db->loadResult();

		// Was there a plugin already installed with the same name?
		if ($id) {

			if (!$this->parent->getOverwrite())
			{
				// Install failed, roll back changes
				$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.JText::_('Module').' "'.$pname.'" '.JText::_('already exists!'));
				return false;
			}

		} else {	
			if ($mtitle && $mposition) {
				$row = & JTable::getInstance('module');
				$row->title		= $mtitle;
				$row->ordering	= ( $mordering == 0 ) ? 0 : $row->getNextOrder("position='".$mposition."'");
				$row->position	= $mposition;
				$row->showtitle	= 0;
				$row->iscore	= 0;
				$row->access	= ($mclient->id) == 1 ? 2 : 0;
				$row->client_id	= $mclient->id;
				$row->module	= $mname;
				$row->published	= $mstate;
				$row->params	= '';
	
				if (!$row->store()) {
					// Install failed, roll back changes
					$this->parent->abort(JText::_('Module').' '.JText::_('Install').': '.$db->stderr(true));
					return false;
				}
			}
		}
		if ($mreplace) {
			$db->setQuery(
				'UPDATE `#__modules` SET' .
				' `published` = 0' .
				' WHERE `module` LIKE "'.$mreplace.'"'
			);
			if (!$db->Query()) {
				$this->parent->abort(JText::_('Module Toolbar Error').': '.$db->stderr(true));
				return false;
			}	
		}

		$status->modules[] = array('name'=>$mname,'client'=>$mclient->name);
	}
}


/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * PLUGIN INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$plugins = &$this->manifest->getElementByPath('plugins');
if (is_a($plugins, 'JSimpleXMLElement') && count($plugins->children())) {

	foreach ($plugins->children() as $plugin)
	{
		$pname		= $plugin->attributes('plugin');
		$pgroup		= $plugin->attributes('group');
		$pnote		= $plugin->attributes('note');

		// Set the installation path
		if (!empty($pname) && !empty($pgroup)) {
			$this->parent->setPath('extension_root', JPATH_ROOT.DS.'plugins'.DS.$pgroup);
		} else {
			$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('No plugin file specified'));
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// If the plugin directory does not exist, lets create it
		$created = false;
		if (!file_exists($this->parent->getPath('extension_root'))) {
			if (!$created = JFolder::create($this->parent->getPath('extension_root'))) {
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('Failed to create directory').': "'.$this->parent->getPath('extension_root').'"');
				return false;
			}
		}

		/*
		 * If we created the plugin directory and will want to remove it if we
		 * have to roll back the installation, lets add it to the installation
		 * step stack
		 */
		if ($created) {
			$this->parent->pushStep(array ('type' => 'folder', 'path' => $this->parent->getPath('extension_root')));
		}

		// Copy all necessary files
		$element = &$plugin->getElementByPath('files');
		if ($this->parent->parseFiles($element, -1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy all necessary files
		$element = &$plugin->getElementByPath('languages');
		if ($this->parent->parseLanguages($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy media files
		$element = &$plugin->getElementByPath('media');
		if ($this->parent->parseMedia($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Database Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */
		$db = &JFactory::getDBO();

		// Check to see if a plugin by the same name is already installed
		$query = 'SELECT `id`' .
				' FROM `#__plugins`' .
				' WHERE folder = '.$db->Quote($pgroup) .
				' AND element = '.$db->Quote($pname);
		$db->setQuery($query);
		if (!$db->Query()) {
			// Install failed, roll back changes
			$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.$db->stderr(true));
			return false;
		}
		$id = $db->loadResult();

		// Was there a plugin already installed with the same name?
		if ($id) {

			if (!$this->parent->getOverwrite())
			{
				// Install failed, roll back changes
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.JText::_('Plugin').' "'.$pname.'" '.JText::_('already exists!'));
				return false;
			}

		} else {
			$row =& JTable::getInstance('plugin');
			$pnote = ( $pnote ) ? $pnote : '';
			$row->name = JText::_(ucfirst($pgroup)).' - '.JText::_(ucfirst($pname)).' '.$pnote;
			$row->ordering = 0;
			$row->folder = $pgroup;
			$row->iscore = 0;
			$row->access = 0;
			$row->client_id = 0;
			$row->element = $pname;
			$row->published = 1;
			$row->params = '';

			if (!$row->store()) {
				// Install failed, roll back changes
				$this->parent->abort(JText::_('Plugin').' '.JText::_('Install').': '.$db->stderr(true));
				return false;
			}
		}

		$status->plugins[] = array('name'=>$pname,'group'=>$pgroup);
	}
}

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * TEMPLATE INSTALLATION SECTION
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$templates = &$this->manifest->getElementByPath('templates');
if (is_a($templates, 'JSimpleXMLElement') && count($templates->children())) {

	foreach ($templates->children() as $template)
	{
		$tname		= $template->attributes('template');
		$tgroup		= $template->attributes('group');
		$ttype		= $template->attributes('type');

		// Set the installation path
		if (!empty($tname) && !empty($tgroup)) {
			$this->parent->setPath('extension_root', JPATH_ROOT.DS.'templates'.DS.str_replace( 'tpl_', '', $tname));
		} else {
			$this->parent->abort(JText::_('Template').' '.JText::_('Install').': '.JText::_('No template file specified'));
			return false;
		}

		/**
		 * ---------------------------------------------------------------------------------------------
		 * Filesystem Processing Section
		 * ---------------------------------------------------------------------------------------------
		 */

		// If the template directory does not exist, lets create it
		$created = false;
		if (!file_exists($this->parent->getPath('extension_root'))) {
			if (!$created = JFolder::create($this->parent->getPath('extension_root'))) {
				$this->parent->abort(JText::_('Template').' '.JText::_('Install').': '.JText::_('Failed to create directory').': "'.$this->parent->getPath('extension_root').'"');
				return false;
			}
		}

		/*
		 * If we created the template directory and will want to remove it if we
		 * have to roll back the installation, lets add it to the installation
		 * step stack
		 */
		if ($created) {
			$this->parent->pushStep(array ('type' => 'folder', 'path' => $this->parent->getPath('extension_root')));
		}

		// Copy all necessary files
		$element = &$template->getElementByPath('files');
		if ($this->parent->parseFiles($element, -1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy all necessary files
		$element = &$template->getElementByPath('languages');
		if ($this->parent->parseLanguages($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		// Copy media files
		$element = &$template->getElementByPath('media');
		if ($this->parent->parseMedia($element, 1) === false) {
			// Install failed, roll back changes
			$this->parent->abort();
			return false;
		}

		$status->templates[] = array('name'=>$tname,'group'=>$tgroup,'type'=>$ttype);
	}
}

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * SETUP DEFAULTS
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

/* NOZIP */

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * UPDATE DATAS
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

$db				=	&JFactory::getDBO();
$query			=	'SELECT s.params FROM #__components AS s WHERE s.option LIKE "%'._MY_COMPONENT.'%"';
$db->setQuery( $query );
$current		=	$db->loadResult();
$current		=	( $current == '' ) ? '1.0.0.Alpha' : substr( strstr( $current, '=' ), 1 );

$versionFile	=	JPATH_ADMINISTRATOR.DS.'components'.DS._MY_COMPONENT.DS.'_VERSION.php';
if ( JFile::exists( $versionFile ) ) {
	$version	=	JFile::read( $versionFile );
}

$updates		=	array();
$updates[0]		=	'1.0.0.Alpha';
$updates[1]		=	'1.0.0.Beta';
$updates[2]		=	'1.0.1.Beta';
$updates[3]		=	'1.0.2.Beta';
$updates[4]		=	'1.0.3.Beta';
$updates[5]		=	'1.0.5.Beta';
$updates[6]		=	'1.0.0.RC';

$i	=	array_search( $current, $updates );
$n	=	array_search( $version, $updates );
for ( $i = $i + 1; $i <= $n; $i++ ) {
	$updateFile	=	JPATH_ADMINISTRATOR.DS.'components'.DS._MY_COMPONENT.DS.'install'.DS.'upgrades'.DS.'upgrade.'.strtolower($updates[$i]).'.'._MY_COMPONENT_NAME.'.sql';
	if ( JFile::exists( $updateFile ) ) {
		$query	=	JFile::read( $updateFile );
		$db->setQuery( $query );
		$db->queryBatch();
	}
}

$query	= 'UPDATE #__components AS s'
		. ' SET s.params = "version='.$version.'"'
		. ' WHERE s.option LIKE "'._MY_COMPONENT.'"'
		;
$db->setQuery( $query );
$db->query();

// Push as SEBLOD 1.x Submenu
$query		=	'SELECT s.id FROM #__components AS s WHERE s.option LIKE "com_cckjseblod"';
$db->setQuery( $query );
$parent		=	$db->loadResult();

$query	= 'UPDATE #__components AS s'
		. ' SET s.parent = '.(int)$parent
		. ' WHERE s.option LIKE "'._MY_COMPONENT.'"'
		;
$db->setQuery( $query );
$db->query();

// --------
$db->setQuery( 'SELECT a.id FROM #__categories AS a WHERE a.alias = "default-submission"' );
$catid		=	$db->loadResult();
$db->setQuery( 'UPDATE #__jseblod_cck_webservices_task_process AS a SET a.value = '.(int)$catid.' WHERE a.taskid = 1 AND a.attribute = "expcat"' );
$db->query();
// --------

/***********************************************************************************************
 * ---------------------------------------------------------------------------------------------
 * OUTPUT TO SCREEN
 * ---------------------------------------------------------------------------------------------
 ***********************************************************************************************/

JHTML::_( 'behavior.mootools' );
$js			=	'window.addEvent("domready",function(){ new SmoothScroll({ duration: 1000 }); });';
$document	=&	JFactory::getDocument();
$document->addScriptDeclaration( $js );

$rows	=	0;
?>

<table class="adminlist">
	<thead>
		<tr>
			<th class="title" colspan="3"><?php echo JText::_('Extension'); ?></th>
			<th width="30%"><?php echo JText::_('Status'); ?></th>
		</tr>
	</thead>
	<tfoot>
		<tr>
			<td colspan="4"></td>
		</tr>
	</tfoot>
	<tbody>
		<tr class="row0">
        	<td width="19"><img src="components/<?php echo _MY_COMPONENT; ?>/assets/images/joomla/icon-17-component.png" width="17" height="17" border="0" alt="Component" /></td>
			<td class="key" colspan="2"><strong><a style="color:grey;" href="<?php echo JRoute::_( 'index.php?option='._MY_COMPONENT ); ?>"><?php echo _MY_COMPONENT_TITLE.' '.JText::_('Component'); ?></a></strong></td>
			<td><strong><font color="green"><?php echo JText::_('Installed'); ?></font></strong></td>
		</tr>
<?php if (count($status->modules)) : ?>
		<tr>
	        <th></th>
			<th><?php echo JText::_('Module'); ?></th>
			<th><?php echo JText::_('Client'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->modules as $module) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
	        <td width="19"><img src="components/<?php echo _MY_COMPONENT; ?>/assets/images/joomla/icon-17-module.png" width="17" height="17" border="0" alt="Module" /></td>
			<td class="key"><?php echo $module['name']; ?></td>
			<td class="key"><?php echo ucfirst($module['client']); ?></td>
			<td><strong><font color="green"><?php echo JText::_('Installed'); ?></font></strong></td>
		</tr>
	<?php endforeach;
endif;
if (count($status->plugins)) : ?>
		<tr>
	        <th></th>
			<th><?php echo JText::_('Plugin'); ?></th>
			<th><?php echo JText::_('Group'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->plugins as $plugin) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
        	<td width="19"><img src="components/<?php echo _MY_COMPONENT; ?>/assets/images/joomla/icon-17-plugin.png" width="17" height="17" border="0" alt="Plugin" /></td>
			<td class="key"><?php echo $plugin['name']; ?></td>
			<td class="key"><?php echo ucfirst($plugin['group']); ?></td>
			<td><strong><font color="green"><?php echo JText::_('Installed'); ?></font></strong></td>
		</tr>
	<?php endforeach;
endif;
if (count($status->templates)) : ?>
		<tr>
	        <th></th>
			<th><?php echo JText::_('Template'); ?></th>
			<th><?php echo JText::_('Type'); ?></th>
			<th></th>
		</tr>
	<?php foreach ($status->templates as $template) : ?>
		<tr class="row<?php echo (++ $rows % 2); ?>">
        	<td width="19"><img src="components/<?php echo _MY_COMPONENT; ?>/assets/images/joomla/icon-17-tool.png" width="17" height="17" border="0" alt="Template" /></td>
			<td class="key"><?php echo $template['name']; ?></td>
			<td class="key"><?php echo ucfirst($template['group']).' ('.ucfirst($template['type']).')'; ?></td>
			<td><strong><font color="green"><?php echo JText::_('Installed'); ?></font></strong></td>
		</tr>
	<?php endforeach;
endif; ?>
	</tbody>
</table>

<div class="clr"></div>

<table class="admintable" >
	<tr>
        <td>
			<img src="components/<?php echo _MY_COMPONENT; ?>/assets/images/joomla/icon-15-native.png" width="75" height="16" alt="15 Native" align="right" />
        </td>
    </tr>
</table>