<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * Model Class
 **/
class CCKjSeblod_WebServiceModelJob extends JModel
{
	var $_id				=	null;
	var $_data				=	null;
	var $_removeData                        =	null;
	var $_viewName                          =	'job';
	var $_viewNames                         =	'jobs';
	var $_viewTable                         =	'jseblod_cck_webservices_jobs';
	var $_viewTableJoin1                    =	'jseblod_cck_webservices_tasks';
	var $_viewTableJoin                     =	'jseblod_cck_webservices_job_task';
	var $_viewTableMore                     =	'jseblod_cck_webservices_job_scheduler';
	
	
	/**
	 * Constructor
	 **/
	function __construct()
	{
		parent::__construct();
		
		$array	=	JRequest::getVar( 'cid',  0, '', 'array' );
		$this->setValues( (int)$array[0] );
	}

	/**
	 * Set Values
	 **/
	function setValues( $id )
	{
		// Set Id and Wipe Data
		$this->_id			=	$id;
		$this->_data		=	null;
		$this->_removeData	=	null;
		
		$this->_categories	=	null;
	}
	
	/**
	 * Get Data from Database
	 **/
	function &getData()
	{
		if ( empty( $this->_data ) ) {
			$row	=&	$this->getTable( $this->_viewNames );
			
			if ( $this->_id ) {
				$row->load( $this->_id );
				if ( ! $row->checked_out ) {
					$user	=&	JFactory::getUser();
					// Checkout!
					$row->checkout( $user->get('id') );
				}
				$this->_data				=&	$row;
				$this->_data->categorystate =	$this->_getCategoryState( $this->_data->category );
			}
		}
		
		return $this->_data;
	}

	/**
	 * Get Data from Database
	 **/
	function _getCategoryState( $categoryId )
	{
		$where	=	' WHERE s.id = '.$categoryId;
      		
  		$query	= ' SELECT s.published'
  				. ' FROM #__'.$this->_viewTable.'_categories AS s'
  				. $where
  				;
    	$this->_db->setQuery( $query );
  		$this->_categorystate	=	$this->_db->loadResult();
		
		return $this->_categorystate;
	}
	
	/**
	 * Store Record(s)
	 **/
	function store()
	{
		$row	=&	$this->getTable( $this->_viewNames );
		$data	=	JRequest::get( 'post' );
		$data['active'] == 100;
    if ($data['mode'] == 0 ){ //select "mode off", active = 0;
      $data['active'] = 0;
      
    }
 	    		
		//$data['description']	=	( $data['description_updated'] == 1 ) ? JRequest::getVar( 'description', '', 'post', 'string', JREQUEST_ALLOWRAW )
				
		// Bind Form Fields to Table
		if ( ! $row->bind( $data ) ) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
				
		// Make Sure Record is Valid
		if ( ! $row->check() ) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
				
		// Store to Database
		if ( ! $row->store() ) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
				
		// Delete Current Attributes(schedular)
		$moreValues	=	'';
		$query = 'DELETE FROM #__'.$this->_viewTableMore.' WHERE jobid = '.$row->id;
		$this->_db->setQuery( $query );
		if ( ! $this->_db->query() ) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		// Save New Attributes(schedular)
		if ( count( $data['attributes_s'] ) ) {
			$nOrder	=	1;
			foreach ( $data['attributes_s'] as $key=>$value ) {
				$moreValues	.=	', ( '.$row->id.', "'.$key.'", "'.$value.'", '.$nOrder.' ) ';
				$nOrder++;
			}
			$moreValues	=	substr( $moreValues, 1 );
			$query	= 'INSERT INTO #__'.$this->_viewTableMore.' ( jobid, attribute, value, ordering )'
				   	. ' VALUES ' . $moreValues;
			$this->_db->setQuery( $query );
			if ( ! $this->_db->query() ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}			
		}
		
		//
	// Delete Current tasks(tasks)
		$moreValues	=	'';
		$query = 'DELETE FROM #__'.$this->_viewTableJoin .' WHERE jobid = '.$row->id;
		$this->_db->setQuery( $query );
		if ( ! $this->_db->query() ) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		// Save New Tasks(TaskS)
		if ( count( $data['jobtask'] ) ) {
			$nOrder	=	1;
			foreach ( $data['jobtask'] as $key=>$value ) {
				//$moreValues	.=	', ( '.$row->id.', "'.$key.'", "'.$value.'", '.$nOrder.' ) ';
				if( $value !='' ){
					$moreValues	.=	', ( '.$row->id.', "'.$value.'", '.$nOrder.' ) ';
					$nOrder++;
				}
				
			}
			$moreValues	=	substr( $moreValues, 1 );
			$query	= 'INSERT INTO #__'.$this->_viewTableJoin.' ( jobid, taskid, ordering )'
				   	. ' VALUES ' . $moreValues;
			$this->_db->setQuery( $query );
			if ( ! $this->_db->query() ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}			
		}
		
		
		
		return $row->id;
	}
	
	/**
	 * Batch Category Process
	 **/
	function batchCategory()
	{
		$cids		=	JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$categoryId	=	JRequest::getInt( 'category' );
		
		$inCids	=	implode( ',', $cids );
		
		if ( $categoryId && count( $cids ) && $inCids )
		{
			$n	=	count( $cids );
			$query = 'UPDATE #__'.$this->_viewTable
				   . ' SET category = '.(int)$categoryId
				   . ' WHERE id IN ( '.$inCids.' )'
				   ;
			$this->_db->setQuery( $query );
			if ( ! $this->_db->query() ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}
		}
		
		return $n;
	}
	
	/**
	 * Live Store Record
	 **/
	function liveStore()
	{
		$liveId		=	JRequest::getInt( 'live_id' );
		$liveTitle	=	JRequest::getVar( 'live_title', '', 'post', 'string', JREQUEST_ALLOWRAW );
		
		if ( $liveId ) {
			$query	= 'UPDATE #__'.$this->_viewTable
					. ' SET title = "'.$liveTitle.'"'
					. ' WHERE id = '.(int)$liveId
					;
			$this->_db->setQuery( $query );
			if ( ! $this->_db->query() ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}
		}
		
		return $liveId;
	}
		
	/**
	 * Get Data from Database
	 **/
	function &getRemoveData()
	{
		if ( empty( $this->_removeData ) )
		{
			$cids 	=	JRequest::getVar( 'cid', array(0), 'post', 'array' );
			$inCids	=	implode( ',', $cids );
			
			$query	= 'SELECT s.id, s.title'
				    . ' FROM #__'.$this->_viewTable.' AS s'
				    . ' WHERE s.id IN ( '.$inCids.' )'
				    ;
			$this->_db->setQuery( $query );
			$this->_removeData	=	$this->_db->loadObjectList();
		}
		
		return $this->_removeData;
	}
		
	/**
	 * Delete Record(s)
	 **/
	function delete( )
	{
		global $mainframe;
		
		$cids	=	JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$inCids	=	implode( ',', $cids );

		// Delete Scheduler
		$query	= 'DELETE s.*'
				. ' FROM #__'.$this->_viewTableMore.' AS s' 
				. ' WHERE s.jobid IN'
				. ' ('.$inCids.')' 
				;
		$this->_db->setQuery( $query );
		if ( ! $this->_db->query() ) {
			$this->setError($this->_db->getErrorMsg());
		}
		
		
		// Delete Job-task
		$query	= 'DELETE s.*'
				. ' FROM #__'.$this->_viewTableJoin.' AS s' 
				. ' WHERE s.jobid IN'
				. ' ('.$inCids.')' 
				;
		$this->_db->setQuery( $query );
		if ( ! $this->_db->query() ) {
			$this->setError($this->_db->getErrorMsg());
		}
		
		
		// Delete the tables jobs
		$row	=&	$this->getTable( $this->_viewNames );
		if ( $n = count( $cids ) )
		{
			foreach($cids as $cid) {
				if ( ! $row->delete( $cid ) ) {
					$this->setError( $this->_db->getErrorMsg() );
					return false;
				}
			}						
		}
		
		return $n;
	}
	
	/**
	 * Publish Record(s)
	 **/
	function publish( $cid = array(), $publish = 1 )
	{
		$user	=&	JFactory::getUser();
			
		if ( count( $cid ) ) {
			JArrayHelper::toInteger( $cid );
			$cids	=	implode( ',', $cid );
				
			$query = 'UPDATE #__'.$this->_viewTable
				   . ' SET published = '.(int)$publish
				   . ' WHERE id IN ( '.$cids.' )'
				   ;
			$this->_db->setQuery( $query );
			if ( ! $this->_db->query() ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}
		}
		
		return true;
	}
	
	/**
	 * Checkout Record
	 **/
	function checkout( $uid = null )
	{
		if ( $this->_id ) {
			$row	=&	$this->getTable( $this->_viewNames );
			
			// Check User Id
			if ( is_null( $uid ) ) {
				$user	=&	JFactory::getUser();
				$uid	=	$user->get('id');
			}
			
			// Checkout!
			if( ! $row->checkout( $uid, $this->_id ) ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}
			return true;
		}
		
		return false;
	}
	
	/**
	 * Checkin Record
	 **/
	function checkin()
	{		
		if ( $this->_id ) {
			$row	=&	$this->getTable( $this->_viewNames );
			
			// Checkin!
			if( ! $row->checkin( $this->_id ) ) {
				$this->setError( $this->_db->getErrorMsg() );
				return false;
			}
		}
		
		return false;
	}
	
	/**
	 * Return Database Query
	 **/
	function _buildQueryCategory( $parentid )
	{
		$query  = 'SELECT s.name, (COUNT(parent.name) - (sub_tree.depth + 1)) AS depth'
				. ' FROM #__jseblod_cck_items_categories AS s,'
				. ' #__jseblod_cck_items_categories AS parent,'
				. ' #__jseblod_cck_items_categories AS sub_parent,'
				. ' ('
		            . ' SELECT s.name, (COUNT(parent.name) - 1) AS depth'
		            . ' FROM #__jseblod_cck_items_categories AS s,'
		            . ' #__jseblod_cck_items_categories AS parent'
		            . ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
		            . ' AND s.id = '.$parentid
		            . ' GROUP BY s.name'
		            . ' ORDER BY s.lft'
					. ' ) AS sub_tree'
				. ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
				. ' AND s.lft BETWEEN sub_parent.lft AND sub_parent.rgt'
				. ' AND sub_parent.name = sub_tree.name'
				. ' GROUP BY s.name'
				. ' HAVING depth <= 1'
				. ' ORDER BY s.lft'
				;
      
		return $query;
	}
	
}
?>