<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/
 
// No Direct Access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

/**
 * Model Class
 * */
class CCKjSeblod_WebServiceModelTask extends JModel {

    var $_id = null;
    var $_data = null;
    var $_removeData = null;
    var $_viewName = 'task';
    var $_viewNames = 'tasks';
    var $_viewTable = 'jseblod_cck_webservices_tasks';
    var $_viewTableJoin = 'jseblod_cck_webservices';
    var $_viewTableMore = 'jseblod_cck_webservices_task_config';
    var $_viewTableMore2 = 'jseblod_cck_webservices_task_process';
    var $_viewTableFields = 'jseblod_cck_webservices_tasks_fields';
    

    /**
     * Constructor
     * */
    function __construct() {
        parent::__construct();

        $array = JRequest::getVar('cid', 0, '', 'array');
        $this->setValues((int) $array[0]);
    }

    /**
     * Set Values
     * */
    function setValues($id) {
        // Set Id and Wipe Data
        $this->_id = $id;
        $this->_data = null;
        $this->_removeData = null;

        $this->_categories = null;
    }

    /**
     * Get Data from Database
     * */
    function &getData() {
        if (empty($this->_data)) {
            $row = & $this->getTable($this->_viewNames);

            if ($this->_id) {
                $row->load($this->_id);
                if (!$row->checked_out) {
                    $user = & JFactory::getUser();
                    // Checkout!
                    $row->checkout($user->get('id'));
                }
                $this->_data = & $row;
                $this->_data->categorystate = $this->_getCategoryState($this->_data->category);
            }
        }

        return $this->_data;
    }

    /**
     * Get Data from Database
     * */
    function _getCategoryState($categoryId) {
        $where = ' WHERE s.id = ' . $categoryId;

        $query = ' SELECT s.published'
                . ' FROM #__' . $this->_viewTable . '_categories AS s'
                . $where
        ;
        $this->_db->setQuery($query);
        $this->_categorystate = $this->_db->loadResult();

        return $this->_categorystate;
    }

    /**
     * Store Record(s)
     * */
    function store() {
        $row = & $this->getTable($this->_viewNames);
        $data = JRequest::get('post');
        
        $custom_exp_fields ='';
        foreach($data['expfields'] as $custom){
         $custom_exp_fields .= $custom.',';
        }
        $data['attributes']['expfields'] = $custom_exp_fields ;
        if ($data['attributes']['field_type'] != 2){
          $data['attributes']['expfields'] = ''; 
        }

        //in case of tasktype not equal 1, because we use the webservice function 's name as name,
        if (!isset($data['name'])) {
            $tname = preg_replace('/[^a-zA-Z0-9_]/', '_', $data['title']);
            $tname = strtolower(preg_replace('/_+/', '_', $tname));
			if ($tname[strlen($tname)-1] == '_') {
				$tname	=	substr($tname, 0, -1);
			}
            $data['name'] = $tname;
        }
        $data['description'] = ( $data['description_updated'] == 1 ) ? JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW) : Helper_Helper::getWysiwygContent('description', $this->_viewNames, $data['id']);
        //$data['webservice']	=	CCK_DB_Result( 'SELECT id FROM #__'.$this->_viewTableJoin.' WHERE name="'.$data['webservice'].'"' );
        
        // Bind Form Fields to Table
        if (!$row->bind($data)) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        // Make Sure Record is Valid
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        // Store to Database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

       
        // Delete Current Params
        $query = 'DELETE FROM #__' . $this->_viewTableMore . ' WHERE taskid = ' . $row->id;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }

        // Save New Params

        $moreValues = '';
        if (count($data['params'])) {
            $nOrder = 1;
            foreach ($data['params'] as $key => $value) { 
                $moreValues .= ', ( ' . $row->id . ', "' . $key . '", "' . $value . '", ' . $nOrder . ' ) ';
                $nOrder++;
            }
            $moreValues = substr($moreValues, 1);
            $query = 'INSERT INTO #__' . $this->_viewTableMore . ' ( taskid, param, value, ordering )'
                    . ' VALUES ' . $moreValues;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        // Delete Current Attributes
        $moreValues = '';
        $query = 'DELETE FROM #__' . $this->_viewTableMore2 . ' WHERE taskid = ' . $row->id;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        // Save New Attributes
        
        if (count($data['attributes'])) {
            $nOrder = 1;
            foreach ($data['attributes'] as $key => $value) {
              
                //add new content type
                if ( $key == 'content_type' && ! $value ) {
                 $com_name = JRequest::getVar('option');
                 $requires = JPATH_ROOT.DS.'administrator'.DS.'components'.DS.$com_name.DS.'helpers'.DS.'helper_webservice.php';
                 require_once($requires);
                 $newct = Helper_Webservice::addContentType($data['new_type']);
                 $value = $newct->name; 
                }
                $moreValues .= ', ( ' . $row->id . ', "' . $key . '", "' . $value . '", ' . $nOrder . ' ) ';
                $nOrder++;
            }
            $moreValues = substr($moreValues, 1);
            $query = 'INSERT INTO #__' . $this->_viewTableMore2 . ' ( taskid, attribute, value, ordering )'
                    . ' VALUES ' . $moreValues;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }
        
        // Delete Current options   $_viewTableFields 
        $query = 'DELETE FROM #__' . $this->_viewTableFields . ' WHERE taskid = ' . $row->id;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }        
        
        // Save New options(used for mappling the fields)
        
        if ($data['options']){
            
            $count = 0;
            $field_options='';
          
            foreach ($data[options] as $data_option){
               if($count == 0 ){
                  $field_options = $data_option;
               }else{
                $field_options .= '||'. $data_option;
               }
               $count ++; 
            }
        
            $moreValues = '( ' . $row->id . ', "' . $field_options . '") ';
            $query = 'INSERT INTO #__' . $this->_viewTableFields . ' ( taskid, options )'
                        . ' VALUES ' . $moreValues;
                        
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }  
                  
        //via type, delete params in the task_process
        if( ($data['process'] !=3) && ($data['id'] ) ){
           $query = "Delete  FROM #__".$this->_viewTableMore2
                   ." WHERE taskid =  ".$data['id']
                   ." AND attribute IN "."('expfields','exp_content_type','expcat','field_type')"
                   ;
          CCK_DB_Delete($query);
        }
        ///

        return $row->id;
    }

    /**
     * Batch Category Process
     * */
    function batchCategory() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $categoryId = JRequest::getInt('category');

        $inCids = implode(',', $cids);

        if ($categoryId && count($cids) && $inCids) {
            $n = count($cids);
            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET category = ' . (int) $categoryId
                    . ' WHERE id IN ( ' . $inCids . ' )'
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return $n;
    }

    /**
     * Live Store Record
     * */
    function liveStore() {
        $liveId = JRequest::getInt('live_id');
        $liveTitle = JRequest::getVar('live_title', '', 'post', 'string', JREQUEST_ALLOWRAW);

        if ($liveId) {
            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET title = "' . $liveTitle . '"'
                    . ' WHERE id = ' . (int) $liveId
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return $liveId;
    }

    /**
     * Get Data from Database
     * */
    function &getExecuteData() {
        /* $cid 	=	JRequest::getInt( 'cid' );

          $query	= 'SELECT s.*'
          . ' FROM #__'.$this->_viewTable.' AS s'
          . ' WHERE s.id = '.$cid
          ;
          $this->_db->setQuery( $query );
          $this->_execData	=	$this->_db->loadObject();

          return $this->_execData; */
        $cid = JRequest::getInt('cid');

        $query = ' SELECT s.*, w.name AS wname, w.url AS wurl, w.login AS wlogin, w.password AS wpassword '
                . ' FROM #__' . $this->_viewTable . ' AS s '
                . ' LEFT JOIN #__' . $this->_viewTableJoin . ' AS w '
                . ' ON s.webservice = w.name '
                . ' WHERE s.id = ' . $cid;

        $this->_db->setQuery($query);
        $this->_execData = $this->_db->loadObject();
        return $this->_execData;
    }

    /**
     * get all params's values for the current task
     */
    function &getExecuteParam() {

        $cid = JRequest::getInt('cid');
        $query = ' SELECT s.param, s.value  '
                . ' FROM #__' . $this->_viewTableMore . ' AS s '
                . ' WHERE s.taskid = ' . $cid;
        $this->_db->setQuery($query);
        $this->_execData = $this->_db->loadAssocList();
        return $this->_execData;
    }

    /**
     * get all process's values(task-process) for the current task
     */
    function &getExecuteProcess() {

        $cid = JRequest::getInt('cid');
        $query = ' SELECT s.attribute, s.value  '
                . ' FROM #__' . $this->_viewTableMore2 . ' AS s '
                . ' WHERE s.taskid = ' . $cid;
        $this->_db->setQuery($query);
        $this->_execData = $this->_db->loadAssocList();
        return $this->_execData;
    }

    /**
     * Get Data from Database
     * */
    function &getRemoveData() {
        if (empty($this->_removeData)) {
            $cids = JRequest::getVar('cid', array(0), 'post', 'array');
            $inCids = implode(',', $cids);

            $query = 'SELECT s.id, s.title'
                    . ' FROM #__' . $this->_viewTable . ' AS s'
                    . ' WHERE s.id IN ( ' . $inCids . ' )'
            ;
            $this->_db->setQuery($query);
            $this->_removeData = $this->_db->loadObjectList();
        }

        return $this->_removeData;
    }

    /**
     * Delete Record(s)
     * */
    function delete() {
        global $mainframe;

        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $inCids = implode(',', $cids);

        // Delete Config
        $query = 'DELETE s.*'
                . ' FROM #__' . $this->_viewTableMore . ' AS s'
                . ' WHERE s.taskid IN'
                . ' (' . $inCids . ')'
        ;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
        }
        
        // Delete Process
        $query = 'DELETE s.*'
                . ' FROM #__' . $this->_viewTableMore2 . ' AS s'
                . ' WHERE s.taskid IN'
                . ' (' . $inCids . ')'
        ;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
        }
        
        //Delete Tasks_Fields(mapping table)
        $query = 'DELETE s.*'
                . ' FROM #__' . $this->_viewTableFields . ' AS s'
                . ' WHERE s.taskid IN'
                . ' (' . $inCids . ')'
        ;
        $this->_db->setQuery($query);
        if (!$this->_db->query()) {
            $this->setError($this->_db->getErrorMsg());
        }
        
                 
        $row = & $this->getTable($this->_viewNames);
        if ($n = count($cids)) {
            foreach ($cids as $cid) {
                if (!$row->delete($cid)) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }

        return $n;
    }

    /**
     * Publish Record(s)
     * */
    function publish($cid = array(), $publish = 1) {
        $user = & JFactory::getUser();

        if (count($cid)) {
            JArrayHelper::toInteger($cid);
            $cids = implode(',', $cid);

            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET published = ' . (int) $publish
                    . ' WHERE id IN ( ' . $cids . ' )'
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return true;
    }

    /**
     * Checkout Record
     * */
    function checkout($uid = null) {
        if ($this->_id) {
            $row = & $this->getTable($this->_viewNames);

            // Check User Id
            if (is_null($uid)) {
                $user = & JFactory::getUser();
                $uid = $user->get('id');
            }

            // Checkout!
            if (!$row->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
        }

        return false;
    }

    /**
     * Checkin Record
     * */
    function checkin() {
        if ($this->_id) {
            $row = & $this->getTable($this->_viewNames);

            // Checkin!
            if (!$row->checkin($this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return false;
    }

    /**
     * Return Database Query
     * */
    function _buildQueryCategory($parentid) {
        $query = 'SELECT s.name, (COUNT(parent.name) - (sub_tree.depth + 1)) AS depth'
                . ' FROM #__jseblod_cck_items_categories AS s,'
                . ' #__jseblod_cck_items_categories AS parent,'
                . ' #__jseblod_cck_items_categories AS sub_parent,'
                . ' ('
                . ' SELECT s.name, (COUNT(parent.name) - 1) AS depth'
                . ' FROM #__jseblod_cck_items_categories AS s,'
                . ' #__jseblod_cck_items_categories AS parent'
                . ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
                . ' AND s.id = ' . $parentid
                . ' GROUP BY s.name'
                . ' ORDER BY s.lft'
                . ' ) AS sub_tree'
                . ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
                . ' AND s.lft BETWEEN sub_parent.lft AND sub_parent.rgt'
                . ' AND sub_parent.name = sub_tree.name'
                . ' GROUP BY s.name'
                . ' HAVING depth <= 1'
                . ' ORDER BY s.lft'
        ;

        return $query;
    }

    //return a webservice by name (all)
    function &ajaxGetWsByName($wsname) {

        $return_empty1 = 1000;
        $return_json   =null;
        $query = ' SELECT s.*  '
                . ' FROM #__' . $this->_viewTableJoin . ' AS s '
                . ' WHERE s.name = "' . $wsname . '"';
        $this->_db->setQuery($query);
        $this->_execData = $this->_db->loadAssoc();
        
        if ($this->_execData) {
            $return_json = json_encode($this->_execData);
            return $return_json;
        } else {
            return $return_empty1;    //$wsname =null, so ws = null.
        }
    }

    function ajaxGetFunctions($filename, $selected) {
        $optList = array();
        $optList[] = JHTML::_('select.option', '', JText::_('SELECT A FUNCTION'));
        $file = JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS . $filename . '.php';

        if (JFile::exists($file)) {
            $buffer = JFile::read($file);
            $search = '#function (.*)\(#sU';
            preg_match_all($search, $buffer, $matches);

            if (sizeof($matches[1])) {
                foreach ($matches[1] as $match) {
                    if ($match != $filename) {
                        $optList[] = JHTML::_('select.option', $match, $match);
                    }
                }
            }
        }

        return JHTML::_('select.genericlist', $optList, 'name', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selected);
    }

    function ajaxGetParams($filename, $function, $taskid) {
        $display = null;
        $file = JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS . $filename . '.php';
        $values = array();

        if ($taskid) {
            $query = 'SELECT param, value FROM #__' . $this->_viewTableMore . ' WHERE taskid=' . $taskid;
            $this->_db->setQuery($query);
            $values = $this->_db->loadObjectList('param');
        }

        if (JFile::exists($file)) {
            $buffer = JFile::read($file);
            $search = '#' . $function . '\((.*)\)#sU';
            preg_match($search, $buffer, $matches);
            if ($matches[1]) {
                // $params	=	explode( ',', $matches[1] ); + foreach etc...
                $param = trim($matches[1]);
                if (strpos($param, ' ') !== false) {
                    $search2 = '#class ' . $function . ' \{(.*)\}#sU';
                    preg_match($search2, $buffer, $matches2);
                    if ($matches2[1]) {
                        $search3 = '#\$(.*);#sU';
                        preg_match_all($search3, $matches2[1], $matches3);
                        if (sizeof($matches3[1])) {
                            $i = 1;
                            foreach ($matches3[1] as $match3) {
                                $value = ( @$values[$match3]->value != '' ) ? $values[$match3]->value : '';
                                $display .= '<tr>'
                                        . '<td width="25" align="right" class="key_jseblod"></td>'
                                        . '<td width="100" align="right" class="key">' . $match3 . '</td>'
                                        . '<td><input class="inputbox" type="text" id="param' . $i . '" name="params[' . $match3 . ']" maxlength="50" size="32" value="' . $value . '" /></td>'
                                        . '</tr>';
                                $i++;
                            }
                        }
                    }
                } else {
                    $param = substr($param, 1);
                    $value = ( @$values[$param]->value != '' ) ? $values[$param]->value : '';
                    $display .= '<tr>'
                            . '<td width="25" align="right" class="key_jseblod"></td>'
                            . '<td width="100" align="right" class="key">' . $param . '</td>'
                            . '<td><input class="inputbox" type="text" id="param1" name="params[' . $param . ']" maxlength="50" size="32" value="' . $value . '" /></td>'
                            . '</tr>';
                }
            }
        }

        return $display;
    }

    /* lsl */

    function & getParamsProcess() {

        $cid = $this->_id;
        //$cid = JRequest::getVar('cid[0]'); ??????demande
        $query = 'SELECT * FROM #__' . $this->_viewTableMore2
                . ' WHERE taskid = ' . '\'' . $cid . '\''
        ;
        $this->_db->setQuery($query);
        if (!($params = $this->_db->loadAssocList())) {
            $this->setError($this->_db->getErrorMsg());
        }

        $paramsprocess = array();
        foreach ($params as $param) {
            $tparam = $param['attribute'];
            $tvalue = $param['value'];
            $paramsprocess[$tparam] = $tvalue;
        }
        return $paramsprocess;
    }

    function & getParamsConfig() {

        $cid = $this->_id;
        //$cid = JRequest::getVar('cid[0]'); ??????demande
        $query = 'SELECT * FROM #__' . $this->_viewTableMore
                . ' WHERE taskid = ' . '\'' . $cid . '\''
        ;
        $this->_db->setQuery($query);
        if (!($params = $this->_db->loadAssocList())) {
            $this->setError($this->_db->getErrorMsg());
        }

        $paramsconfig = array();
        foreach ($params as $param) {
            $tparam = $param['param'];
            $tvalue = $param['value'];
            $paramsconfig[$tparam] = $tvalue;
        }
        return $paramsconfig;
    }

    //get a task's webservice
    function getWsByTask($viewTableJoin, $viewTable, $id) {

        $query = ' SELECT s.*  '
                . ' FROM #__' . $viewTableJoin . ' AS s '
                . ' LEFT JOIN #__' . $viewTable . ' AS t  ON s.name = t.webservice'
                . ' WHERE t.id = "' . $id . '"';

        return CCK_DB_Object($query);
    }

}

?>
