<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

/**
 * 	Model Class
 **/
class CCKjSeblod_WebServiceModelTasks extends JModel
{
	var $_data 			=	null;
	var $_total 		=	null;
	var $_pagination	=	null;
	var $_branch		=	null;
	var $_viewName		=	'task';
	var $_viewNames		=	'tasks';
	var $_viewTable		=	'jseblod_cck_webservices_tasks';
	var $_viewTableJoin	=	'jseblod_cck_webservices';
	
	/**
	 * Constructor
	 **/
	function __construct()
	{
        parent::__construct();
		
        global $mainframe, $option;
		$controller = JRequest::getWord('controller');
		$task		=	JRequest::getVar( 'layout' );
		
        // Get Pagination Request Variables
        $limit		=	$mainframe->getUserStateFromRequest( 'global.list.limit', 'limit', $mainframe->getCfg( 'list_limit' ), 'int' );
        $limitstart =	$mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.limitstart', 'limitstart', 0, 'int' );
		
        // In case Limit has been Changed, Adjust it
        $limitstart	=	( $limit != 0 ? ( floor( $limitstart / $limit ) * $limit ) : 0 );
		
        $this->setState( 'limit', $limit );
        $this->setState( 'limitstart', $limitstart );
	}
	
	/**
	 * Get Data from Database
	 **/
	function getData()
	{
		if ( empty( $this->_data ) )
		{
			$query			=	$this->_buildQuery();
			$this->_data	=	$this->_getList( $query, $this->_pagination->limitstart, $this->_pagination->limit );
		}
		
		return $this->_data;
	}
	
	/**
	 * Get Total
	 **/
	function getTotal()
	{
        if ( empty( $this->_total ) ) {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount( $query );
        }
		
        return $this->_total;
	}
	
	/**
	 * Get Pagination Object
	 **/
	function getPagination()
	{
        if ( empty( $this->_pagination ) ) {
            jimport( 'joomla.html.pagination' );
            $this->_pagination	=	new JPagination( $this->getTotal(), $this->getState( 'limitstart' ), $this->getState( 'limit' ) );
        }
		
        return $this->_pagination;
	}
	
	/**
	 * Return Database Query
	 **/
	function _buildQuery()
	{
		global $mainframe;
		
		$where		=	$this->_buildContentWhere();
		$orderby	=	$this->_buildContentOrderBy();
		
		$query = 'SELECT s.*, cc.title AS categorytitle, cc.color AS categorycolor, cc.introchar AS categoryintrochar, cc.colorchar AS categorycolorchar, sc.title as webserviceTitle, u.name AS editor'
				.' FROM #__'.$this->_viewTable.' AS s'
				.' LEFT JOIN #__'.$this->_viewTable.'_categories AS cc ON cc.id = s.category'
				.' LEFT JOIN #__'.$this->_viewTableJoin.' AS sc ON sc.id = s.webservice'
				.' LEFT JOIN #__users AS u ON u.id = s.checked_out'
				. $where
				. $orderby
				;
		
		return $query;
	}
	
	/**
	 * Return Where into Query 
	 **/
	function _buildContentWhere()
	{
		global $mainframe, $option;
		$db	=&	JFactory::getDBO();
		$controller			=	JRequest::getWord( 'controller' );
		$task				=	JRequest::getVar( 'layout' );
		$categoryFilter 	=	JRequest::getInt( 'categoryfilter' );
		$selectCat 			=	JRequest::getInt( 'selectcat' );
				
		$filter_category	= ( $categoryFilter ) ? 0 : ( ( $selectCat ) ? $selectCat : $mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_category',	'filter_category',	0,		'int' ) );
		$filter_process		=	$mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_process',	'filter_process',	'',		'string' );
		$filter_state		= ( $task == 'element' ) ? 'P' : ( ( $categoryFilter ) ? '' : $mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_state',		'filter_state',		'',			'word' ) );
		$filter_search		= ( $categoryFilter ) ? 5 : $mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_search',	'filter_search',	0,		'int' );
		$search				= ( $categoryFilter ) ? $categoryFilter : $mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.search',			'search',			'',		'string' );
		$search				= JString::strtolower( $search );
		
		$where	=	'';
		
		if ( $filter_category ) {
			$categories	=	$this->_getBranch( $filter_category );
			if ( $categories ) {
				$where .=	( $where ) ? ' AND s.category IN ('.$categories.')' : ' WHERE s.category IN ('.$categories.')';
			}
		}
		
		if ( $filter_process != '' ) {
			$where .=	( $where ) ? ' AND s.process = '.$filter_process : ' WHERE s.process = '.$filter_process;
		}
		
		if ( $filter_state ) {
			if ( $filter_state == 'P' ) {
				$where .= ($where) ? ' AND s.published = 1' : ' WHERE s.published = 1';
			} else if ($filter_state == 'U' ) {
				$where .= ($where) ? ' AND s.published = 0' : ' WHERE s.published = 0';
			}
		}
		
		if ( $search ) {
			if ( $filter_search == 5 ) {
				$where	.=	( $where ) ? ' AND s.category = '.(int)$search : ' WHERE s.category = '.(int)$search;
			} else if ( $filter_search == 4 ) {
				$where	.=	( $where ) ? ' AND LOWER(cc.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) : ' WHERE LOWER(cc.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			} else if ( $filter_search == 3 ) {
				$where	.=	( $where ) ? ' AND s.id = '.(int)$search : ' WHERE s.id = '.(int)$search;
			} else if ( $filter_search == 2 ) {
				$where	.=	( $where ) ? ' AND LOWER(s.description) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) : ' WHERE LOWER(s.description) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			} else if ( $filter_search == 1 ) {
				$where	.=	( $where ) ? ' AND LOWER(s.name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) : ' WHERE LOWER(s.name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			} else {
				$where	.=	( $where ) ? ' AND LOWER(s.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) : ' WHERE LOWER(s.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
			}
		}
		
		return $where;
	}
	
	/**
	 * Return OrderBy into Query 
	 **/
	function _buildContentOrderBy() 
	{	
		global $mainframe, $option;
		$controller	=	JRequest::getWord( 'controller' );
		$task		=	JRequest::getVar( 'layout' );
		
		$filter_order		=	$mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_order',		'filter_order',		's.title',	'cmd' );
		$filter_order_Dir	=	$mainframe->getUserStateFromRequest( $option.'.'.$controller.'.'.$task.'.filter_order_Dir',	'filter_order_Dir',	'asc',		'cmd' );
		
		$orderby	=	' ORDER BY '.$filter_order .' '. $filter_order_Dir;
		
		return $orderby;
	}
	
	/**
	 * Get Branch
	 **/
	function _getBranch( $currentId )
	{
		if ( empty( $this->_branch ) ) {
			$query = 'SELECT s.id, (COUNT(parent.id) - (branch.depth + 1)) AS depth'
					.' FROM #__'.$this->_viewTable.'_categories AS s,'
					.' #__'.$this->_viewTable.'_categories AS parent,'
					.' #__'.$this->_viewTable.'_categories AS subparent,'
					.' ('
						.' SELECT s.id, (COUNT(parent.id) - 1) AS depth'
						.' FROM #__'.$this->_viewTable.'_categories AS s,'
						.' #__'.$this->_viewTable.'_categories AS parent'
						.' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
						.' AND s.id ='.$currentId
						.' GROUP BY s.id'
						.' ORDER BY s.lft'
						.' ) AS branch'
					.' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
					.' AND s.lft BETWEEN subparent.lft AND subparent.rgt'
					.' AND subparent.id = branch.id'
					.' GROUP BY s.id'
					.' ORDER BY s.lft';
			
			$this->_db->setQuery( $query );
			$this->_branch = $this->_db->loadResultArray();
			if ( is_array( $this->_branch ) ) {
				$this->_branch = implode( ',', $this->_branch );
			}
		}
		
		return( $this->_branch );
	}
	
}
?>