<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

/**
 * Model Class
 * */
class CCKjSeblod_WebServiceModelWebService extends JModel {

    var $_id = null;
    var $_data = null;
    var $_removeData = null;
    var $_viewName = 'webservice';
    var $_viewNames = 'webservices';
    var $_viewTable = 'jseblod_cck_webservices';
    var $_viewTableMore = 'jseblod_cck_webservices_tasks';
    var $_viewTableMore2 = 'jseblod_cck_webservices_task_config';
    var $_viewTableMore3 = 'jseblod_cck_webservices_task_process';

    /**
     * Constructor
     * */
    function __construct() {
        parent::__construct();

        $array = JRequest::getVar('cid', 0, '', 'array');
        $this->setValues((int) $array[0]);
    }

    /**
     * Set Values
     * */
    function setValues($id) {
        // Set Id and Wipe Data
        $this->_id = $id;
        $this->_data = null;
        $this->_removeData = null;

        $this->_categories = null;
    }

    /**
     * Get Data from Database
     * */
    function &getData() {
        if (empty($this->_data)) {
            $row = & $this->getTable($this->_viewNames);

            if ($this->_id) {
                $row->load($this->_id);
                if (!$row->checked_out) {
                    $user = & JFactory::getUser();
                    // Checkout!
                    $row->checkout($user->get('id'));
                }
                $this->_data = & $row;
                $this->_data->categorystate = $this->_getCategoryState($this->_data->category);
            }
        }

        return $this->_data;
    }

    /**
     * Get Data from Database
     * */
    function _getCategoryState($categoryId) {
        $where = ' WHERE s.id = ' . $categoryId;

        $query = ' SELECT s.published'
                . ' FROM #__' . $this->_viewTable . '_categories AS s'
                . $where
        ;
        $this->_db->setQuery($query);
        $this->_categorystate = $this->_db->loadResult();

        return $this->_categorystate;
    }

    /**
     * Store Record(s)
     * */
    function store() {
        
        $row = & $this->getTable($this->_viewNames);
        $data = JRequest::get('post');
        /*
         * if type not equal "SOAP +WSDL", generate the name.(Class name => name)
         */
        //Require_once(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_cckjseblod_webservice'.DS.'helpers'.DS.'helper_webservice.php');
        //Helper_webservice::resetTaskConfig($data['name'], $this->_viewTableMore, $this->_viewTableMore2 ); 
         
        if ($data['type'] != 1) {

            $name1 = strtolower($data['title']);
            $name1 = str_replace(' ', '_', $name1);
            $data['name'] = $name1;
            
        }
        
        /*
         * generate the filename() .
         */
        if (($data['type'] == 3)) { //ftp mode

            if ($data['lastfile'] == 0) {
                $data['filename'] = $data['file_prefix_name'] . '.' . $data['file_ext_name'];
                $data['url'] = $data['url'] . DS . $data['filename'];
            } else { //for lastfile equal 1, so we go to folder for finding the lasting file.
                //
                set_time_limit(0);
                $url = explode("://", $data['url']);
                $url_id_passwd = $url[0] . "://" . $data['login'] . ":" . $data['password'] . "@" . $url[1];
                $handler = opendir($url_id_passwd);
                $filesarray = array();
                //get the files'time index.
                while ($filename = readdir($handler)) {
                    if (($filename != ".") && ($filename) != "..") {
                        $index = filemtime($url_id_passwd . '/' . $filename);
                        $filesarray[$index] = $filename;
                    }
                }
                closedir($handler);
                ksort($filesarray);
                $fnn = array_pop($filesarray); //the last file's name
                $data['url'] = $data['url'] . DS . $fnn;
                $data['filename'] = $fnn;
            }
        }
        $data['description'] = ( $data['description_updated'] == 1 ) ? JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW) : Helper_Helper::getWysiwygContent('description', $this->_viewNames, $data['id']);


        /*
         * type equal "local"
         * Get the file and save on a web server, address prefixed
         */
        if ($data['type'] == 4) { //local mode :   
            //localmode
           
            if($data['localmode'] == 2){
                //  localmode equal 2--remote address, option: get lastfile = 0
                if ($data['lastfile'] == 0) {
                    $data['filename'] = $data['file_prefix_name'] . '.' . $data['file_ext_name'];
                    $data['url'] = $data['url'] . DS . $data['filename'];
                }else { //  for lastfile equal 1, so go to rep for finding the lastest file.
                    set_time_limit(0);
                    $handler = opendir($data['url']);
                    if(!$handler){
                      return false;
                    }
                    $filesarray = array();
                    //get the lastest file's time index.
                    while ($filename = readdir($handler)) {
                        if (($filename != ".") && ($filename) != "..") {
                            $index = filemtime($data['url'] . DS . $filename);
                            $filesarray[$index] = $filename;
                        }
                    }
                    closedir($handler);
                    ksort($filesarray);
                    $fnn = array_pop($filesarray);
                    $data['url'] = $data['url'] . DS . $fnn;
                    $data['filename'] = $fnn;
                }
            }else{
                //localmode equal 1, uploader a file
           
                $upload_file = JRequest::getVar('upload_file', null, 'files', 'array');
                $upload_file1 = JRequest::getVar('upload_file1');/////
                if ($upload_file && $upload_file['name'] && $upload_file['size'] > 0) {
                    $destFolder = JPATH_COMPONENT_ADMINISTRATOR . DS . 'helpers' . DS . 'userfiles';
                    $file_date = date('Ymd');
                    //$fileName = $file_date . '_' . JFile::makeSafe($upload_file['name']);
                    $fileName =  JFile::makeSafe($upload_file['name']);
                    $src = $upload_file['tmp_name'];
                    $dest = $destFolder . DS . $fileName;
                    if (!JFile::upload($src, $dest)) {
                        return false;
                    }
                    $data['url'] = $dest;
                    $data['filename'] = $fileName;
                }elseif ( $upload_file1 != null) {
                    
                }else {
                    return false;
                }
            }
        }

        /*
         * type != 1, not webservice
         */

        if ($data['type'] !=1){
           $data['generate'] = null;

        }




        // save the httpaddr for wsdl if uploader a wsdl
        if ($data['generate']) {
            $upload_file = JRequest::getVar('upload_file', null, 'files', 'array');
            if ($upload_file && $upload_file['name'] && $upload_file['size'] > 0){
               $com_name = JRequest::getVar('option');
               $fileName = JFile::makeSafe($upload_file['name']);
               //$httpwsdl = JUri::base().'components'.DS.$com_name.DS.'helpers'.DS.'userfiles'.DS.$fileName;
               define(DH, '/');
               $httpwsdl = JUri::base().'components'.DH.$com_name.DH.'helpers'.DH.'userfiles'.DH.$fileName;
               $data['url'] = $httpwsdl;
            }
        }
        
        
        // Bind Form Fields to Table
        if (!$row->bind($data)) {
            //$this->setError($this->_db->getErrorMsg());
            $this->setError("cccccc");
            return false;
        }
    
        // Make Sure Record is Valid
        if (!$row->check()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
        // Store to Database
        if (!$row->store()) {
            $this->setError($this->_db->getErrorMsg());
            return false;
        }
        
        // Generate Class
       
        if ($data['generate']) {
            $upload_file = JRequest::getVar('upload_file', null, 'files', 'array');
            
            //by uploading
            if ($upload_file && $upload_file['name'] && $upload_file['size'] > 0) {
                //$config   = & JFactory::getConfig();
                //$tempFolder = $config->getValue('config.tmp_path');   //Jconfig
                //$com_name = JRequest::getVar('option');
                $destFolder = JPATH_ADMINISTRATOR.DS.'components'.DS.$com_name.DS.'helpers'.DS.'userfiles';
                //$fileName = JFile::makeSafe($upload_file['name']);
                //$httpwsdl = JUri::base().'components'.DS.$com_name.DS.'helpers'.DS.'userfiles'.DS.$fileName;
                
                $src      = $upload_file['tmp_name'];
                $dest     = $destFolder . DS . $fileName;
                if (!JFile::upload($src, $dest)) {
                    return false;
                }
                $wsdl = $httpwsdl;
                
            } else { //by url 
                if (strpos($data['url'], 'http') === false) {
                    return false;
                }
                $wsdl = $data['url'];
                $pre = explode('http://', $wsdl);
                $wsdl = "http://" . $data['login'] . ':' . $data['password'] . '@' . $pre[1];
               
            }

            $remote = $wsdl;
            $classname = $data['name'];
            $dest = JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS;

            if (JFile::exists($dest . $classname . '.php')) {
                JFile::delete($dest . $classname . '.php');
            }

            require_once( JPATH_COMPONENT . DS . 'helpers' . DS . 'wsdl2php' . DS . 'functions.php' );
            generate_php($wsdl, $remote, $classname, $dest);

            if (!JFile::exists($dest . $classname . '.php')) {
                return false;
            }
        }
        return $row->id;
        
    }

    /**
     * Batch Category Process
     * */
    function batchCategory() {
        $cids = JRequest::getVar('cid', array(0), 'post', 'array');
        $categoryId = JRequest::getInt('category');

        $inCids = implode(',', $cids);

        if ($categoryId && count($cids) && $inCids) {
            $n = count($cids);
            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET category = ' . (int) $categoryId
                    . ' WHERE id IN ( ' . $inCids . ' )'
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return $n;
    }

    /**
     * Live Store Record
     * */
    function liveStore() {
        $liveId = JRequest::getInt('live_id');
        $liveTitle = JRequest::getVar('live_title', '', 'post', 'string', JREQUEST_ALLOWRAW);

        if ($liveId) {
            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET title = "' . $liveTitle . '"'
                    . ' WHERE id = ' . (int) $liveId
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return $liveId;
    }

    /**
     * Get Data from Database
     * */
    function &getRemoveData() {
        if (empty($this->_removeData)) {
            $cids = JRequest::getVar('cid', array(0), 'post', 'array');
            $inCids = implode(',', $cids);

            $query = 'SELECT s.id, s.title'
                    . ' FROM #__' . $this->_viewTable . ' AS s'
                    . ' WHERE s.id IN ( ' . $inCids . ' )'
            ;
            $this->_db->setQuery($query);
            $this->_removeData = $this->_db->loadObjectList();
        }

        return $this->_removeData;
    }

    /**
     * Delete Record(s)
     * */
    function delete($deleteMode) {
        global $mainframe;
        $arr = array();

        $cids = JRequest::getVar('cid', array(0), 'post', 'array');

        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod_webservice' . DS . 'tables');
        //get all the webservice name via cids
        foreach ($cids as $cid) {
            //$row =& JTable::getInstance($this->_viewNames, 'Table');
            $row = & $this->getTable($this->_viewNames);
            $row->load($cid);
            $name = $row->name;
            array_push($arr, '\'' . $name . '\'');  //array of the webservice name
        }
        //get the taskid in order to delete the task-param

        $taskidarray = array();
        foreach ($arr as $ar) {
            $db = & JFactory::getDBO();
            $query = 'SELECT t.id '
                    . ' FROM #__' . $this->_viewTableMore . ' AS t '
                    . ' WHERE t.webservice = '
                    . $ar
            ;
            $db->setQuery($query);

            $ids = $db->loadResultArray();

            foreach ($ids as $idtask) {
                array_push($taskidarray, $idtask);
            }
        }

        $task_ids = implode(",", $taskidarray);

        //via webservice, get all the taskid
        //delete the task-param
        $query = 'DELETE v.* '
                . 'FROM #__' . $this->_viewTableMore2 . ' AS v '
                . 'WHERE v.taskid IN '
                . '(' . $task_ids . ')'
        ;
        $db->setQuery($query);
        $db->execute($query);


        //delete the task-process
        $query = 'DELETE v.* '
                . 'FROM #__' . $this->_viewTableMore3 . ' AS v '
                . 'WHERE v.taskid IN '
                . '(' . $task_ids . ')'
        ;
        $db->setQuery($query);
        $db->execute($query);



        //delete the tasks under the webservice


        $arr1 = implode(",", $arr);

        $db = & JFactory::getDBO();
        $query = 'DELETE s.*'
                . ' FROM #__' . $this->_viewTableMore . ' AS s '
                . 'WHERE s.webservice IN '
                . '(' . $arr1 . ')'
        ;

        $db->setQuery($query);
        $db->execute($query);


        $row = & $this->getTable($this->_viewNames);

        if ($n = count($cids)) {
            foreach ($cids as $cid) {
                $row->load($cid);
                if ($row->name) {
                    if (JFile::exists(JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS . $row->name . '.php')) {
                        JFile::delete(JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS . $row->name . '.php');
                    }
                }
                if (!$row->delete($cid)) {
                    $this->setError($this->_db->getErrorMsg());
                    return false;
                }
            }
        }

        return $n;
    }

    /**
     * Publish Record(s)
     * */
    function publish($cid = array(), $publish = 1) {
        $user = & JFactory::getUser();

        if (count($cid)) {
            JArrayHelper::toInteger($cid);
            $cids = implode(',', $cid);

            $query = 'UPDATE #__' . $this->_viewTable
                    . ' SET published = ' . (int) $publish
                    . ' WHERE id IN ( ' . $cids . ' )'
            ;
            $this->_db->setQuery($query);
            if (!$this->_db->query()) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return true;
    }

    /**
     * Checkout Record
     * */
    function checkout($uid = null) {
        if ($this->_id) {
            $row = & $this->getTable($this->_viewNames);

            // Check User Id
            if (is_null($uid)) {
                $user = & JFactory::getUser();
                $uid = $user->get('id');
            }

            // Checkout!
            if (!$row->checkout($uid, $this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
            return true;
        }

        return false;
    }

    /**
     * Checkin Record
     * */
    function checkin() {
        if ($this->_id) {
            $row = & $this->getTable($this->_viewNames);

            // Checkin!
            if (!$row->checkin($this->_id)) {
                $this->setError($this->_db->getErrorMsg());
                return false;
            }
        }

        return false;
    }

    /**
     * Return Database Query
     * */
    function _buildQueryCategory($parentid) {
        $query = 'SELECT s.name, (COUNT(parent.name) - (sub_tree.depth + 1)) AS depth'
                . ' FROM #__jseblod_cck_items_categories AS s,'
                . ' #__jseblod_cck_items_categories AS parent,'
                . ' #__jseblod_cck_items_categories AS sub_parent,'
                . ' ('
                . ' SELECT s.name, (COUNT(parent.name) - 1) AS depth'
                . ' FROM #__jseblod_cck_items_categories AS s,'
                . ' #__jseblod_cck_items_categories AS parent'
                . ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
                . ' AND s.id = ' . $parentid
                . ' GROUP BY s.name'
                . ' ORDER BY s.lft'
                . ' ) AS sub_tree'
                . ' WHERE s.lft BETWEEN parent.lft AND parent.rgt'
                . ' AND s.lft BETWEEN sub_parent.lft AND sub_parent.rgt'
                . ' AND sub_parent.name = sub_tree.name'
                . ' GROUP BY s.name'
                . ' HAVING depth <= 1'
                . ' ORDER BY s.lft'
        ;

        return $query;
    }

}

?>