<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );

/**
 * View Class
 **/
class CCKjSeblod_WebServiceViewJob extends JView
{
	var $_viewName		=	'job';
	var $_viewNames		=	'jobs';
	var $_viewTable		=	'jseblod_cck_webservices_jobs';
	var $_viewTableJoin	=	'jseblod_cck_webservices';
	var $_viewTitle		=	'JOB';
	var $_viewTitles	=	'JOBS';
	var $_viewTableMore	= 	'jseblod_cck_webservices_job_scheduler' ;
	var $_viewTableMore2= 	'jseblod_cck_webservices_tasks' ;
	var $_viewTableMore3= 	'jseblod_cck_webservices_job_task' ;
	
	

	/**
	 * Display Delete Toolbar
	 **/
	function _displayDeleteToolbar() 
	{
		JToolBarHelper::title(   JText::_( $this->_viewTitle ).': <small><small>[ '.JText::_( 'Delete' ).' ]</small></small>', $this->_viewNames.'.png' );
		JToolBarHelper::custom( 'cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_( 'Close' ), false ); //JToolBarHelper::cancel( 'cancel', 'Close' );
		JToolBarHelper::divider();
		Helper_Display::help( $this->_viewNames );
	}
	
	/**
	 * Display Toolbar
	 **/
	function _displayToolbar( $isNew, $doCopy, $isAuth, $id )
	{
		
		if ( $isAuth ) {
			JToolBarHelper::custom( 'save', 'save_jseblod', 'save_jseblod', JText::_( 'Save' ), false ); //JToolBarHelper::save();
			JToolBarHelper::custom( 'apply', 'apply_jseblod', 'apply_jseblod', JText::_( 'Apply' ), false ); //JToolBarHelper::apply();;
			JToolBarHelper::spacer();
		}
		if ( $isNew || $doCopy )  {
			$text = $doCopy ? JText::_( 'Copy' ) : JText::_( 'New' );
			JToolBarHelper::title(   JText::_( $this->_viewTitle ).': <small><small>[ '.$text.' ]</small></small>', $this->_viewNames.'.png' );
			JToolBarHelper::custom( 'cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_( 'Cancel' ), false ); //JToolBarHelper::cancel();
		} else {
			$text = $isAuth ? JText::_( 'Edit' ) : JText::_( 'View' );
			JToolBarHelper::title(   JText::_( $this->_viewTitle ).': <small><small>[ '.$text.' ]</small></small>', $this->_viewNames.'.png' );
		  JToolBarHelper::custom( 'cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_( 'Close' ), false ); //JToolBarHelper::cancel( 'cancel', 'Close' );
		}
		JToolBarHelper::divider();
		Helper_Display::help( $this->_viewName );
	}
	
	/**
	 * Display Default View
	 **/
	function display( $tpl = null )
	{
		require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_cckjseblod'.DS.'helpers'.DS.'jseblod_helper.php' );
		
		// Get Request Vars
		global $mainframe, $option;
		$user 		=&	JFactory::getUser();
		$controller =	JRequest::getWord( 'controller' );
		$document	=&	JFactory::getDocument();
		$model 		=&	$this->getModel();
		
		$doDelete	=	JRequest::getVar( 'doDelete', false );
		$doProcess =   JRequest::getVar( 'doProcess', false );
		$isAuth 	=	( $user->get( 'gid' ) < _EDIT_ACCESS ) ? 0 : 1;
		
		if ( $doDelete ) {
			
			$removeItems	=&	$this->get( 'RemoveData' );
			
			$this->assignRef( 'option', $option );
			$this->assignRef( 'controller', $controller );
			$this->assignRef( 'removeItems', $removeItems );
			
			$this->_displayDeleteToolbar();

		} else if( $doProcess ) {

			$viewItem 			=&	$this->get( 'ExecuteData' );
			$process			=	$viewItem->process;
			$processAttributes	=&	$this->get( 'ParamsProcess' );
			
			require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_cckjseblod_webservice'.DS.'helpers'.DS.'helper_runtime.php' );
      require_once( JPATH_ADMINISTRATOR.DS.'components'.DS.'com_cckjseblod_webservice'.DS.'helpers'.DS.'helper_webservice.php' );
			
			$runtime	=	new Helper_Runtime;
			$runtime->start();
			$returnData		= 	Helper_Webservice::callTask( $viewItem, $this->_viewTableMore );
			$processData	= 	Helper_Webservice::processTask( $returnData, $process, $processAttributes, $viewItem->name );
			$runtime->stop();
			$processTime	=	$runtime->spent();
			
			$this->assignRef( 'option', $option );
			$this->assignRef( 'controller', $controller );
			$this->assignRef( 'document', $document );
			$this->assignRef( 'returnData', $returnData);
			$this->assignRef( 'processData', $processData );
			$this->assignRef( 'process', $process );
			$this->assignRef( 'viewItem', $viewItem );
			$this->assignRef( 'processTime', $processTime );
			
		} else {

			jimport('joomla.filesystem.folder');
			
			// Get Data from Model
			$viewItem 	=&	$this->get( 'Data' );
			$process	  =&	$this->get( 'ParamsProcess' );
			
			// Set Flags
			$isNew		=	( @$viewItem->id > 0 ) ? 0 : 1;
			$doCopy		=	JRequest::getVar( 'doCopy', true );
			
			// Checking!
			if ( JTable::isCheckedOut( $user->get( 'id' ), @$viewItem->checked_out ) ) {
				$msg = JText::sprintf( 'DESCBEINGEDITTED', '', $viewItem->title );
				$mainframe->redirect( _LINK_VIEW_2, $msg, 'notice' );
			}
						
			// Set Wysiwyg Modal
			$modals['description']			=	Helper_Display::quickModalWysiwyg( 'Description', $controller, 'description', 'pagebreak', 0, @$viewItem->id, false );
			$tooltips['link_description']	=	Helper_Display::quickTooltipAjaxLink( 'Description', $controller, 'description', @$viewItem->id );
						
			// Set Published List ( Boolean List )
			$selectedPublished	=	( $isNew ) ? 1 : $viewItem->published;
			$lists['published']	=	JHTML::_( 'select.booleanlist', 'published', 'class="inputbox"', $selectedPublished );
			
			// Set Category List ( Select List )
			$optionCategories	=	array();
			$optionCategories[]	=	JHTML::_( 'select.option',  '', JText::_( 'SELECT A CATEGORY' ), 'value', 'text' );
			$optionCategories[]	=	JHTML::_( 'select.option',  '1', JText::_( 'QUICK CATEGORY' ), 'value', 'text' );
			$optionCategories[] =	JHTML::_( 'select.option', '<OPTGROUP>', JText::_( 'Categories' ) );
			$optionCategories	=	( ! $isNew && ! $viewItem->categorystate ) ? array_merge( $optionCategories, Helper_Helper::getViewCategories( $this->_viewTable.'_categories', true, false ) )
																			   : array_merge( $optionCategories, Helper_Helper::getViewCategories( $this->_viewTable.'_categories', true, true ) );
			$optionCategories[]		=	JHTML::_( 'select.option', '</OPTGROUP>', '' );
			$selectFilterInCategory	=	( JRequest::getInt( 'filter_search' ) == 5 ) ? JRequest::getInt( 'search' ) : '';
			$selectFilterCategory	=	( $selectFilterInCategory || JRequest::getInt( 'filter_category' ) ) ? ( ( $selectFilterInCategory ) ? $selectFilterInCategory : JRequest::getInt( 'filter_category' ) ) : ( 1 );
			$selectedCategory   	=	( ! $isNew ) ? $viewItem->category : $selectFilterCategory;
			$lists['category']		=	JHTML::_( 'select.genericlist', $optionCategories, 'category', 'class="inputbox required required-enabled" size="1"', 'value', 'text', $selectedCategory );

			
			
			// Catagory
			$optCategories			=	array();
			$optCategories[]		=	JHTML::_('select.option', '', JText::_( 'SELECT A CATEGORY' ) );
			$optCategories			=	array_merge( $optCategories, HelperjSeblod_Helper::getJoomlaCategories() );
			$listsProcess['catid']	=	JHTML::_( 'select.genericlist', $optCategories, 'attributes[catid]', 'class="inputbox" size="1"', 'value', 'text', @$process['catid'] );

			// Content Type
			$optContentType			=	array();
			$optContentType[]		=	JHTML::_('select.option', '', JText::_( 'SELECT A CONTENT TYPE' ) );
			$optContentType			=	array_merge( $optContentType, HelperjSeblod_Helper::getContentTypesByName( -1 ) );
			$listsProcess['ctype']	=	JHTML::_( 'select.genericlist', $optContentType, 'attributes[content_type]', 'class="inputbox required required-enabled" size="1"', 'value', 'text', @$process['content_type'], 'content_type' );

			// State
			$optState				=	array();
			$optState[]				=	JHTML::_('select.option', '1', JText::_( 'Published' ) );
			$optState[]				=	JHTML::_('select.option', '0', JText::_( 'Unpublished' ) );
			$optState[]				=	JHTML::_('select.option', '-1', JText::_( 'Archived' ) );
			$listsProcess['state']	=	JHTML::_( 'select.genericlist', $optState, 'attributes[state]', 'class="inputbox" size="1"', 'value', 'text', @$process['state'] );

			// Access
			$optAccess				=	array();
			$optAccess[]			=	JHTML::_('select.option', '0', JText::_( 'Public' ) );
			$optAccess[]			=	JHTML::_('select.option', '1', JText::_( 'Registered' ) );
			$optAccess[]			=	JHTML::_('select.option', '2', JText::_( 'Special' ) );
			$listsProcess['access']	=	JHTML::_( 'select.genericlist', $optAccess, 'attributes[access]', 'class="inputbox" size="1"', 'value', 'text', @$process['access'] );

			// Author
			$optUsers				=	array();
			$optUsers				=	array_merge( $optUsers, HelperjSeblod_Helper::getJoomlaAuthors( 24 ) );
			$listsProcess['author']	=  JHTML::_('select.genericlist', $optUsers, 'attributes[author]', 'class="inputbox"', 'value', 'text', @$process['author'] );

			// Separator
			$optSeparator[]				=	JHTML::_('select.option', ',', JText::_( ',' ) );
			$optSeparator[] 			=	JHTML::_('select.option', ';', JText::_( ';' ) );
			$optSeparator[] 			=	JHTML::_('select.option', '|', JText::_( '|' ) );
			$optSeparator[] 			=	JHTML::_('select.option', '#', JText::_( '#' ) );
			$listsProcess['separator']	=	JHTML::_('select.genericlist', $optSeparator, 'attributes[separator]',  'size="1" class="inputbox"', 'value', 'text', @$process['separator'] );
			
			// Force UTF8
			$listsProcess['utf8']		=	JHTML::_( 'select.booleanlist', 'attributes[force_utf8]', 'class="inputbox"', @$process['force_utf8'] );
			
			$langEnabled		=	CCK_LANG_Enable();
			if ( $langEnabled ) {
				$langs	=	CCK_LANG_List();
				if ( sizeof( $langs ) ) {
					$optLangs	=	array();
					$default	=	CCK_Lang_Default();
					$optLangs[]	=	JHTML::_( 'select.option', '', JText::_( 'SELECT A LANGUAGE' ) );
					foreach( $langs as $lang ) {
						if ( $default == $lang->shortcode ) {
							$optLangs[]		=	JHTML::_( 'select.option', 0, $lang->name );
						} else {
							$optLangs[]		=	JHTML::_( 'select.option', $lang->id, $lang->name );
						}
					}
					$listsProcess['lang']	=	JHTML::_( 'select.genericlist', $optLangs, 'attributes[lang]', 'class="inputbox" size="1"', 'value', 'text', @$process['lang'] );
				}
			}
			
			// Schedule
			$optSchedule		=	array();
			$optSchedule[] 		=	JHTML::_( 'select.option', 0, JText::_( 'OFF' ) );
			$optSchedule[] 		=	JHTML::_( 'select.option', 1, JText::_( 'MODE ONE TIME' ) );
			$optSchedule[] 		=	JHTML::_( 'select.option', 2, JText::_( 'MODE DAILY' ) );
			$optSchedule[] 		=	JHTML::_( 'select.option', 100, JText::_( 'MODE CUSTOM' ) );
			//$optSchedule[] 		=	JHTML::_( 'select.option', 3, JText::_( 'MODE WEEKLY' ) );
			//$optSchedule[] 		=	JHTML::_( 'select.option', 4, JText::_( 'MODE MONTHLY' ) );
			//$optSchedule[] 		=	JHTML::_( 'select.option', 8, JText::_( 'MODE Every 8s' ) );
			//$optSchedule[] 		=	JHTML::_( 'select.option', 9, JText::_( 'MODE Every 90s' ) );
			$selectSchedule		=	( ! $isNew ) ? $viewItem->mode : 0;
			$lists['schedule'] 	=	JHTML::_( 'select.genericlist', $optSchedule, 'mode', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectSchedule );
			
      // Date
      
      
      //$lists['calendar'] = JHTML::calendar("1982-12-12', , $id, $format = '%Y-%m-%d', $attribs = null)
      
      $lists['calendar'] 	= JHTML::_('behavior.calendar' );
      
      //$lists['calendar'] 	= JHTML::_('calendar');
			$currentdate1	= date( "Y-m-d   H:i:s ",time());
			
			// value saved in the db
			$query5  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "hour" ';     
              
      $query6  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "minute" ';
      $query7  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "startdate" ';                
      $dhour   = CCK_DB_Result( $query5 ); 
      $dminute = CCK_DB_Result( $query6 );
      $dstartdate =  CCK_DB_Result( $query7 );
			
		
      if( $isNew ) {
        $hour1      =  0 + 	substr( $currentdate1, 13, 2 );
        $minute1    =  0 +   substr( $currentdate1, 16, 2 ); 
        $dstartdate = date( "Y-m-d ",time());    
                                                                     
      }else{
          switch( $viewItem->mode ){
          case 0:              
            break;
          case 1:
          case 2:
          case 100:
              $hour1    = $dhour;
              $minute1  = $dminute;
             break;
          default:  
          }            
      }                                                    			
		
			
			$starthours 	= 	array(99 => '- Select hour -', 0 => '00h',01 => '01h', 02 => '02h', 03 => '03h', 04 => '04h',05 => '05h', 06 => '06h', 07 => '07h', 8 => '08h', 9 => '09h', 10 => '10h', 11 => '11h', 12 => '12h' ,13 => '13h', 14 => '14h', 15 => '15h', 16 => '16h',17 => '17h', 18 => '18h', 19 => '19h', 20 => '20h', 21 => '21h', 22 => '22h', 23 => '23h');
 			$options 		= array();
 			foreach( $starthours as $key=>$value ) :
			   $options[] 	= JHTML::_('select.option', $key, $value);
			endforeach;
			$lists['starthour'] = JHTML::_('select.genericlist', $options, 'attributes_s[hour]', 'class="inputbox"', 'value', 'text', @$hour1);
			
			$startminute		=	array(99 => '- Select minute -', 0 => '00m', 01 => '01m', 02 => '02m', 03 => '03m', 04 => '04m',05 => '05m', 06 => '06m', 07 => '07m', 8 => '08m',9 => '09m', 10 => '10m', 11 => '11m', 12 => '12m' ,13 => '13m', 14 => '14m', 15 => '15m', 16 => '16m',17 => '17m', 18 => '18m', 19 => '19m', 20 => '20m',21 => '21m', 22 => '22m', 23 => '23m', 24 => '24m',25 => '25m', 26 => '26m', 27 => '27m', 28 => '28m',29 => '29m', 30 => '30m', 31 => '31m', 32 => '32m' ,33 => '33m', 34 => '34m', 35 => '35m', 36 => '36m',37 => '37m', 38 => '38m', 39 => '39m', 40 => '40m',41 => '41m', 42 => '42m', 43 => '43m', 44 => '44m',45 => '45m', 46 => '46m', 47 => '47m', 48 => '48m',49 => '49m', 50 => '50m', 51 => '51m', 52 => '52m' ,53 => '53m', 54 => '54m', 55 => '55m', 56 => '56m',57 => '57m', 58 => '58m', 59 => '59m');
			foreach($startminute as $key=>$value) :
			    $options1[] = JHTML::_('select.option', $key, $value);
			endforeach;
			$lists['startminute'] = JHTML::_('select.genericlist', $options1, 'attributes_s[minute]', 'class="inputbox"', 'value', 'text', @$minute1);
			
			//custom
			$custom_hours	= 	array(99 => '- Hour - ', 0=>'00h',01 => '01h', 02 => '02h', 03 => '03h', 04 => '04h',05 => '05h', 06 => '06h', 07 => '07h', 8 => '08h', 9 => '09h', 10 => '10h', 11 => '11h', 12 => '12h' ,13 => '13h', 14 => '14h', 15 => '15h', 16 => '16h',17 => '17h', 18 => '18h', 19 => '19h', 20 => '20h', 21 => '21h', 22 => '22h', 23 => '23h', 24 => '24h');
  			$optionsch 		= array();
 			foreach( $custom_hours as $key=>$value ) :
			   $optionsch[] 	= JHTML::_('select.option', $key, $value);
			endforeach;
      
      			
		  //custom schedular in the db  
      $query  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "custom_hour" ';     
       
      $query1  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "custom_minute" '; 
                 
      $query2  = 'SELECT s.value FROM #__'.$this->_viewTableMore.' AS s'
                 .' WHERE s.jobid ='.@$viewItem->id. ' AND s.attribute = '
                 .' "custom_second" ';            
                     
      $custom_hour     = CCK_DB_Result( $query );  
      $custom_minute   = CCK_DB_Result( $query1 );
      $custom_second   = CCK_DB_Result( $query2 );  
           
      if( $isNew ){
         $c_hour     =  99 ;
         $c_minute   =  99 ;
         $c_second   =  99 ;
         
      }else{
           switch( $viewItem->mode ){
           case 0: 
             break;
           case 100:
              $c_hour    = $custom_hour;  
              $c_minute  = $custom_minute;
              $c_second  = $custom_second;
             break;
           default:  
           }           
             
      }        
		 		
		
			
			$lists['custom_hour'] = JHTML::_('select.genericlist', $optionsch, 'attributes_s[custom_hour]', 'class="inputbox"', 'value', 'text', @$c_hour);
			
			$custom_minutes		=	array(99 => '- Minute -', 0=>'00m', 01 => '01m', 02 => '02m', 03 => '03m', 04 => '04m',05 => '05m', 06 => '06m', 07 => '07m', 8 => '08m',9 => '09m', 10 => '10m', 11 => '11m', 12 => '12m' ,13 => '13m', 14 => '14m', 15 => '15m', 16 => '16m',17 => '17m', 18 => '18m', 19 => '19m', 20 => '20m',21 => '21m', 22 => '22m', 23 => '23m', 24 => '24m',25 => '25m', 26 => '26m', 27 => '27m', 28 => '28m',29 => '29m', 30 => '30m', 31 => '31m', 32 => '32m' ,33 => '33m', 34 => '34m', 35 => '35m', 36 => '36m',37 => '37m', 38 => '38m', 39 => '39m', 40 => '40m',41 => '41m', 42 => '42m', 43 => '43m', 44 => '44m',45 => '45m', 46 => '46m', 47 => '47m', 48 => '48m',49 => '49m', 50 => '50m', 51 => '51m', 52 => '52m' ,53 => '53m', 54 => '54m', 55 => '55m', 56 => '56m',57 => '57m', 58 => '58m', 59 => '59m');
			$optionscm 		= array();
			foreach($custom_minutes as $key=>$value) :
			    $optionscm[] = JHTML::_('select.option', $key, $value);
			endforeach;
			$lists['custom_minute'] = JHTML::_('select.genericlist', $optionscm, 'attributes_s[custom_minute]', 'class="inputbox"', 'value', 'text', @$c_minute);
			
			$custom_seconds		=	array(99 => '- Second -', 0 => '00s', 01 => '01s', 02 => '02s', 03 => '03s', 04 => '04s',05 => '05s', 06 => '06s', 07 => '07s', 8 => '08s',9 => '09s', 10 => '10s', 11 => '11s', 12 => '12s' ,13 => '13s', 14 => '14s', 15 => '15s', 16 => '16s',17 => '17s', 18 => '18s', 19 => '19s', 20 => '20s',21 => '21s', 22 => '22s', 23 => '23s', 24 => '24s',25 => '25s', 26 => '26s', 27 => '27s', 28 => '28s',29 => '29s', 30 => '30s', 31 => '31s', 32 => '32s' ,33 => '33s', 34 => '34s', 35 => '35s', 36 => '36s',37 => '37s', 38 => '38s', 39 => '39s', 40 => '40s',41 => '41s', 42 => '42s', 43 => '43s', 44 => '44s',45 => '45s', 46 => '46s', 47 => '47s', 48 => '48s',49 => '49s', 50 => '50s', 51 => '51s', 52 => '52s' ,53 => '53s', 54 => '54s', 55 => '55s', 56 => '56s',57 => '57s', 58 => '58s', 59 => '59s');
			$optionscs 		= array();
			foreach($custom_seconds as $key=>$value) :
			    $optionscs[] = JHTML::_('select.option', $key, $value);
			endforeach;
			
			
			
			
			
			
			$lists['custom_second'] = JHTML::_('select.genericlist', $optionscs, 'attributes_s[custom_second]', 'class="inputbox"', 'value', 'text', @$c_second);
			
			// plateforme/method
			$optPlateforme			=	array();
			$optPlateforme[] 		=	JHTML::_( 'select.option', 0, JText::_( 'PHP' ) );
			//$optPlateforme[] 		=	JHTML::_( 'select.option', 1, JText::_( 'WINDOWS' ) );
			//$optPlateforme[] 		=	JHTML::_( 'select.option', 2, JText::_( 'UNIVERSAL' ) );
			$lists['plateforme'] 	=	JHTML::_( 'select.genericlist', $optPlateforme, 'attributes_s[plateforme]', 'size="1" class="inputbox required required-enabled"', 'value', 'text', '0' );
			
			//--
			
			//tasks
			$optTasks				=	array();
			$optTasks[]				=	JHTML::_('select.option', '', JText::_( 'SELECT A TASK' ) );
			$taskIdNames				=   Helper_Helper::getTaskIdName($this->_viewTableMore2);
			asort ($taskIdNames);
			reset ($taskIdNames);
			foreach($taskIdNames as $key=>$value) :
			    $optTasks[] = JHTML::_('select.option', $key, $value);
			endforeach;
			if ( ! $isNew ){
				$query = 'SELECT s.taskid FROM #__'.$this->_viewTableMore3.' AS s LEFT JOIN '
					.'#__'.$this->_viewTable.' AS b ON b.id = s.jobid WHERE b.id = '.$viewItem->id .' ORDER BY s.ordering'
					;
				$res = CCK_DB_ObjectList( $query );
			}else{
				$res = array();
			}
			
			
			
			$lists['jobtask1']		=	JHTML::_( 'select.genericlist', $optTasks, 'jobtask[]', 'class="inputbox required required-enabled" size="1"', 'value', 'text', @$res[0]->taskid );
			$lists['jobtask2']		=	JHTML::_( 'select.genericlist', $optTasks, 'jobtask[]', 'class="inputbox" size="1"', 'value', 'text', @$res[1]->taskid );
			$lists['jobtask3']		=	JHTML::_( 'select.genericlist', $optTasks, 'jobtask[]', 'class="inputbox" size="1"', 'value', 'text', @$res[2]->taskid );
			$lists['jobtask4']		=	JHTML::_( 'select.genericlist', $optTasks, 'jobtask[]', 'class="inputbox" size="1"', 'value', 'text', @$res[3]->taskid );
			$lists['jobtask5']		=	JHTML::_( 'select.genericlist', $optTasks, 'jobtask[]', 'class="inputbox" size="1"', 'value', 'text', @$res[4]->taskid );
			
			// Push Data to Template
			$this->assignRef( 'option', $option );
			$this->assignRef( 'controller', $controller );
			$this->assignRef( 'document',	$document );
			$this->assignRef( 'doCopy', $doCopy );
			$this->assignRef( 'viewItem', $viewItem );
			$this->assignRef( 'isNew', $isNew );
			$this->assignRef( 'lists', $lists );
			$this->assignRef( 'modals', $modals );
			$this->assignRef( 'tooltips', $tooltips );
			$this->assignRef( 'taskname', $taskname );
			$this->assignRef( 'listsProcess', $listsProcess );
			$this->assignRef( 'langEnabled', $langEnabled );
			$this->assignRef( 'startdate', $dstartdate );
			
			$this->_displayToolbar( $isNew, $doCopy, $isAuth, @$viewItem->id );
		}
		
		parent::display( $tpl );
	}
	
}
?>