<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/

// No Direct Access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * View Class
 * */
class CCKjSeblod_WebServiceViewTask extends JView {

    var $_viewName = 'task';
    var $_viewNames = 'tasks';
    var $_viewTable = 'jseblod_cck_webservices_tasks';
    var $_viewTableJoin = 'jseblod_cck_webservices';
    var $_viewTitle = 'TASK';
    var $_viewTitles = 'TASKS';
    var $_viewTableMore = 'jseblod_cck_webservices_task_config';

    
    /**
     * Display Delete Toolbar
     * */
    function _displayDeleteToolbar() {
        JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . JText::_('Delete') . ' ]</small></small>', $this->_viewNames . '.png');
        JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Close'), false); //JToolBarHelper::cancel( 'cancel', 'Close' );
        JToolBarHelper::divider();
        Helper_Display::help($this->_viewNames);
    }

    /**
     * Display Toolbar
     * */
    function _displayToolbar($isNew, $doCopy, $isAuth, $id) {
        if ($id) {
            Helper_Display::quickExecTack($id);
        }
        JToolBarHelper::divider();
        if ($isAuth) {
            JToolBarHelper::custom('save', 'save_jseblod', 'save_jseblod', JText::_('Save'), false); //JToolBarHelper::save();
            JToolBarHelper::custom('apply', 'apply_jseblod', 'apply_jseblod', JText::_('Apply'), false); //JToolBarHelper::apply();;
            JToolBarHelper::spacer();
        }
        if ($isNew || $doCopy) {
            $text = $doCopy ? JText::_('Copy') : JText::_('New');
            JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . $text . ' ]</small></small>', $this->_viewNames . '.png');
            JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Cancel'), false); //JToolBarHelper::cancel();
        } else {
            $text = $isAuth ? JText::_('Edit') : JText::_('View');
            JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . $text . ' ]</small></small>', $this->_viewNames . '.png');
            JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Close'), false); //JToolBarHelper::cancel( 'cancel', 'Close' );
        }
        JToolBarHelper::divider();
        Helper_Display::help($this->_viewName);
    }

    /**
     * Display Default View
     * */
    function display($tpl = null) {
        require_once( JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_cckjseblod' . DS . 'helpers' . DS . 'jseblod_helper.php' );

        // Get Request Vars
        global $mainframe, $option;
        $user = & JFactory::getUser();
        $controller = JRequest::getWord('controller');
        $document = & JFactory::getDocument();
        $model = & $this->getModel();

        $doDelete = JRequest::getVar('doDelete', false);
        $doProcess = JRequest::getVar('doProcess', false);
        $isAuth = ( $user->get('gid') < _EDIT_ACCESS ) ? 0 : 1;

        if ($doDelete) {

            $removeItems = & $this->get('RemoveData');

            $this->assignRef('option', $option);
            $this->assignRef('controller', $controller);
            $this->assignRef('removeItems', $removeItems);

            $this->_displayDeleteToolbar();
        } else if ($doProcess) {

            //manipulation with stape(template, -->process bar)
            $viewItem = & $this->get('ExecuteData');  //datas of tasks with associated ws.
            $configs = & $this->get('ParamsConfig');   //datas of tasks-configs

            $process = $viewItem->process;
       
            $step = $viewItem->step;
            $processAttributes = & $this->get('ParamsProcess');

            ///option for the file zip
            $optFileZip = array();
            $optFileZip[] =  JHTML::_('select.option',  '1', JText::_('YES'));
            $optFileZip[] =  JHTML::_('select.option',  '0', JText::_('NO'));
            $zip =  JHTML::_('select.radiolist', $optFileZip, 'zip' );

            $this->assignRef('zip', $zip);
            $this->assignRef('viewName', $this->_viewName);
            $this->assignRef('document', $document);
            $this->assignRef('step', $step);
            $this->assignRef('viewTableMore', $this->_viewTableMore);
            $this->assignRef('viewItem', $viewItem);
            $this->assignRef('process', $process);
            $this->assignRef('processAttributes', $processAttributes);
            $this->assignRef('configs', $configs);
            $this->assignRef('configs', $configs);
            $this->assignRef('viewTable', $this->_viewTable);
            $this->assignRef('viewTableJoin', $this->_viewTableJoin);
        } else {

            jimport('joomla.filesystem.folder');

            // Get Data from Model
            $viewItem = & $this->get('Data');
            $viewItem_ty = & $this->get('ExecuteData');
            $process = & $this->get('ParamsProcess');
            $configs = & $this->get('ParamsConfig');

            // Set Flags
            $isNew = ( @$viewItem->id > 0 ) ? 0 : 1;
            $doCopy = JRequest::getVar('doCopy', true);

            // Checking!
            if (JTable::isCheckedOut($user->get('id'), @$viewItem->checked_out)) {
                $msg = JText::sprintf('DESCBEINGEDITTED', '', $viewItem->title);
                $mainframe->redirect(_LINK_VIEW_2, $msg, 'notice');
            }

            // Set Wysiwyg Modal
            $modals['description'] = Helper_Display::quickModalWysiwyg('Description', $controller, 'description', 'pagebreak', 0, @$viewItem->id, false);
            $tooltips['link_description'] = Helper_Display::quickTooltipAjaxLink('Description', $controller, 'description', @$viewItem->id);

            // Set Published List ( Boolean List )
            $selectedPublished = ( $isNew ) ? 1 : $viewItem->published;
            $lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $selectedPublished);

            // Set Category List ( Select List )
            $optionCategories = array();
            $optionCategories[] = JHTML::_('select.option', '', JText::_('SELECT A CATEGORY'), 'value', 'text');
            $optionCategories[] = JHTML::_('select.option', '1', JText::_('QUICK CATEGORY'), 'value', 'text');
            $optionCategories[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('Categories'));
            $optionCategories = (!$isNew && !$viewItem->categorystate ) ? array_merge($optionCategories, Helper_Helper::getViewCategories($this->_viewTable . '_categories', true, false)) : array_merge($optionCategories, Helper_Helper::getViewCategories($this->_viewTable . '_categories', true, true));
            $optionCategories[] = JHTML::_('select.option', '</OPTGROUP>', '');
            $selectFilterInCategory = ( JRequest::getInt('filter_search') == 5 ) ? JRequest::getInt('search') : '';
            $selectFilterCategory = ( $selectFilterInCategory || JRequest::getInt('filter_category') ) ? ( ( $selectFilterInCategory ) ? $selectFilterInCategory : JRequest::getInt('filter_category') ) : ( 1 );
            $selectedCategory = (!$isNew ) ? $viewItem->category : $selectFilterCategory;
            $lists['category'] = JHTML::_('select.genericlist', $optionCategories, 'category', 'class="inputbox required required-enabled" size="1"', 'value', 'text', $selectedCategory);

        
            $thismodel = $this->getModel();
            if (!$isNew){
              $ws = $thismodel->getWsByTask($this->_viewTableJoin, $this->_viewTable, $viewItem->id);
              $type =$ws->type;
            }else{
              $type = 999999 ; //new
            }
                      
            switch ($type){
              case "5":
                $krumo = 0;
                $export_content = 1;
                $export_csv   = 0;
                $import8 = 0;
                $free_php = 0;
              break;
              
              case "4":
                $krumo = 1;
                $export_content = 0;
                $export_csv   = 0;
                $import8 = 1;
                $free_php = 0;
              break;
              
              case "3":
                $krumo = 1;
                $export_content = 0;
                $export_csv   = 0;
                $import8 = 1;
                $free_php = 0;
              break;
              
              case "2":
                $krumo = 1;
                $export_content = 0;
                $export_csv   = 0;
                $import8 = 1;
                $free_php = 0;
              break;
              
              case "1":
                $krumo = 1;
                $export_content = 0;
                $export_csv   = 1;
                $import8 = 1;
                $free_php = 0;
              break;
              
              case "99":
                $krumo = 0;
                $export_content = 1;
                $export_csv   = 0;
                $import8 = 0;
                $free_php = 0;
              break;
              default:
                $krumo = 1;
                $export_content = 1;
                $export_csv   = 1;
                $import8 = 1;
                $free_php = 1;
              break;
            }
            
            // Process
            $optProcess = array();     
            $optProcess[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('PRESETS'));
            if($krumo)          {$optProcess[] = JHTML::_('select.option', 0, JText::_('TASK DISPLAY KRUMO'),'value','text',!$krumo);}
            if($export_content) {$optProcess[] = JHTML::_('select.option', 3, JText::_('TASK EXPORT CONTENT'),'value','text' ,!$export_content);}
            if($export_csv)     {$optProcess[] = JHTML::_('select.option', 2, JText::_('TASK EXPORT CSV'),'value','text',!$export_csv );}
            if($import8)        {$optProcess[] = JHTML::_('select.option', 1, JText::_('TASK IMPORT CSV'),'value','text', !$import8);}
            $optProcess[] = JHTML::_('select.option', '</OPTGROUP>', '');
            //$optProcess[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('CUSTOM'));
            //if($free_php)       {$optProcess[] = JHTML::_('select.option', -1, JText::_('TASK FREE PHP'),'value','text',!$free_php); }
            //$optProcess[] = JHTML::_('select.option', '</OPTGROUP>', '');
            $selectProcess = (!$isNew ) ? $viewItem->process : 0;
            $lists['process'] = JHTML::_('select.genericlist', $optProcess, 'process', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectProcess, 'process');

            // Step
            $optStep = array();
            $optStep[] = JHTML::_('select.option', 0, JText::_('ALL'));
            $optStep[] = JHTML::_('select.option', 1, JText::_('1'));
            $optStep[] = JHTML::_('select.option', 5, JText::_('5'));
            $optStep[] = JHTML::_('select.option', 10, JText::_('10'));
            $optStep[] = JHTML::_('select.option', 50, JText::_('50'));
            $optStep[] = JHTML::_('select.option', 100, JText::_('100'));
            $optStep[] = JHTML::_('select.option', 200, JText::_('200'));
            $optStep[] = JHTML::_('select.option', 300, JText::_('300'));
            $optStep[] = JHTML::_('select.option', 500, JText::_('500'));

            $selectStep = (!$isNew ) ? $viewItem->step : 0;
            $lists['step'] = JHTML::_('select.genericlist', $optStep, 'step', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectStep, 'step');


            // Catagory
            $optCategories = array();
            $optCategories[] = JHTML::_('select.option', '', JText::_('SELECT A CATEGORY'));
            $optCategories = array_merge($optCategories, HelperjSeblod_Helper::getJoomlaCategories());
            $listsProcess['catid'] = JHTML::_('select.genericlist', $optCategories, 'attributes[catid]', 'class="inputbox" size="1"', 'value', 'text', @$process['catid']);

            // Content Type  /////
            $optContentType = array();
            $optContentType[] = JHTML::_('select.option', '', JText::_('SELECT A CONTENT TYPE'));
            $optContentType[] = JHTML::_('select.option', 0, JText::_('ADD NEW CONTENT TYPE')); /////
            $optContentType = array_merge($optContentType, HelperjSeblod_Helper::getContentTypesByName(-1));
            $listsProcess['ctype'] = JHTML::_('select.genericlist', $optContentType, 'attributes[content_type]', 'class="inputbox required required-enabled" size="1"', 'value', 'text', @$process['content_type'], 'content_type');




            // State
            $optState = array();
            $optState[] = JHTML::_('select.option', '1', JText::_('Published'));
            $optState[] = JHTML::_('select.option', '0', JText::_('Unpublished'));
            $optState[] = JHTML::_('select.option', '-1', JText::_('Archived'));
            $listsProcess['state'] = JHTML::_('select.genericlist', $optState, 'attributes[state]', 'class="inputbox" size="1"', 'value', 'text', @$process['state']);

            // Access
            $optAccess = array();
            $optAccess[] = JHTML::_('select.option', '0', JText::_('Public'));
            $optAccess[] = JHTML::_('select.option', '1', JText::_('Registered'));
            $optAccess[] = JHTML::_('select.option', '2', JText::_('Special'));
            $listsProcess['access'] = JHTML::_('select.genericlist', $optAccess, 'attributes[access]', 'class="inputbox" size="1"', 'value', 'text', @$process['access']);

            // Author
            $optUsers = array();
            $optUsers = array_merge($optUsers, HelperjSeblod_Helper::getJoomlaAuthors(24));
            $listsProcess['author'] = JHTML::_('select.genericlist', $optUsers, 'attributes[author]', 'class="inputbox"', 'value', 'text', @$process['author']);

            // Separator
            $optSeparator[] = JHTML::_('select.option', ',', JText::_(','));
            $optSeparator[] = JHTML::_('select.option', ';', JText::_(';'));
            $optSeparator[] = JHTML::_('select.option', '|', JText::_('|'));
            $optSeparator[] = JHTML::_('select.option', '#', JText::_('#'));
            $listsProcess['separator'] = JHTML::_('select.genericlist', $optSeparator, 'attributes[separator]', 'size="1" class="inputbox"', 'value', 'text', @$process['separator']);

            // Force UTF8
            $listsProcess['utf8'] = JHTML::_('select.booleanlist', 'attributes[force_utf8]', 'class="inputbox"', @$process['force_utf8']);

            //Debug
            $listsProcess['debug'] = JHTML::_('select.booleanlist', 'attributes[debug]', 'class="inputbox"', @$process['debug']);
            $langEnabled = CCK_LANG_Enable();
            if ($langEnabled) {
                $langs = CCK_LANG_List();
                if (sizeof($langs)) {
                    $optLangs = array();
                    $default = CCK_Lang_Default();
                    $optLangs[] = JHTML::_('select.option', '', JText::_('SELECT A LANGUAGE'));
                    foreach ($langs as $lang) {
                        if ($default == $lang->shortcode) {
                            $optLangs[] = JHTML::_('select.option', 0, $lang->name);
                        } else {
                            $optLangs[] = JHTML::_('select.option', $lang->id, $lang->name);
                        }
                    }
                    $listsProcess['lang'] = JHTML::_('select.genericlist', $optLangs, 'attributes[lang]', 'class="inputbox" size="1"', 'value', 'text', @$process['lang']);
                }
            }

            // Schedule
            $optSchedule = array();
            $optSchedule[] = JHTML::_('select.option', 0, JText::_('OFF'));
            $optSchedule[] = JHTML::_('select.option', 1, JText::_('MODE ONE TIME'));
            $optSchedule[] = JHTML::_('select.option', 2, JText::_('MODE DAILY'));
            $optSchedule[] = JHTML::_('select.option', 3, JText::_('MODE WEEKLY'));
            $optSchedule[] = JHTML::_('select.option', 4, JText::_('MODE MONTHLY'));
            $selectSchedule = (!$isNew ) ? $viewItem->mode : 0;
            $lists['schedule'] = JHTML::_('select.genericlist', $optSchedule, 'mode', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectSchedule);


            // WebService
            $optWebservice = array();
            $optWebservice[] = JHTML::_('select.option', '', JText::_('SELECT ACCESS2'));
            $webservices = Helper_Helper::getElemList($this->_viewTableJoin, 'title', 'name');

            if (sizeof($webservices)) {
                foreach ($webservices as $webservice) {
                    if (JFile::exists(JPATH_COMPONENT . DS . 'helpers' . DS . 'class' . DS . $webservice->value . '.php') or ($webservice->type != 1)) {
                        $optWebservice[] = JHTML::_('select.option', $webservice->value, $webservice->text);
                    }
                }
            }
            $selectWebservice = (!$isNew ) ? $viewItem->webservice : '';
            $lists['webservice'] = JHTML::_('select.genericlist', $optWebservice, 'webservice', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectWebservice);



            //if a webservice task.
            $wstype = @$model->getWsByTask($this->_viewTableJoin, $this->_viewTable, @$viewItem->id)->type;
            if (!$isNew && $wstype == 1) {

                $lists['function'] = $model->ajaxGetFunctions($viewItem->webservice, $viewItem->name);
                $lists['params'] = $model->ajaxGetParams($viewItem->webservice, $viewItem->name, $viewItem->id);
            }

            //params for export(catid, setid ...)
            ///
            /**************
             * Export CSV *
             ************* */
            $optFields = array();
            $optFields[] = JHTML::_('select.option', 'title', JText::_('TITLE'));
            $optFields[] = JHTML::_('select.option', 'introtext', JText::_('ALIAS'));
            $optFields[] = JHTML::_('select.option', 'fulltext', JText::_('STATE'));
            $optFields[] = JHTML::_('select.option', 'created', JText::_('CREATED DATE'));
            $optFields[] = JHTML::_('select.option', 'authord', JText::_('AUTHOR'));
            $optFields[] = JHTML::_('select.option', 'introtext_as_field', JText::_('INTROTEXT'));
            $selectFields[] = 'title';
            $selectFields[] = 'introtext_as_field';         //$optFields, 'fields[]'
            $lists['fields'] = JHTML::_('select.genericlist', $optFields, 'attributes[fields]', 'size="6" class="inputbox" multiple="multiple"', 'value', 'text', $selectFields);

            // lsl
            //choose cat
            
            $optExp_Categories = array();
            $optExp_Categories[] = JHTML::_('select.option', '', JText::_('SELECT A CATEGORY'));
            $optExp_Categories = array_merge($optExp_Categories, HelperjSeblod_Helper::getJoomlaCategories());
            $category = @$process['expcat'];
            $selectCategory = ( @$category ) ? $category : '';
            $lists['exp_catid'] = JHTML::_('select.genericlist', $optExp_Categories, 'attributes[expcat]', 'class="inputbox " size="1"', 'value', 'text', $selectCategory);

           
            // choose the fields for exporting

            $optselectJContent = array();
            $optselectJContent[] = JHTML::_('select.option', 'introtext_as_field', JText::_('CUSTOM FIELDS')); //INTROTEXT AS FIELDS
            $optselectJContent[] = JHTML::_('select.option', 'id', JText::_('ID'));
            $optselectJContent[] = JHTML::_('select.option', 'title', JText::_('TITLE'));
            $optselectJContent[] = JHTML::_('select.option', 'alias', JText::_('ALIAS'));
            $optselectJContent[] = JHTML::_('select.option', 'state', JText::_('STATE'));
            $optselectJContent[] = JHTML::_('select.option', 'sectionid', JText::_('SECTIONID'));
            $optselectJContent[] = JHTML::_('select.option', 'catid', JText::_('CATEGORY ID'));
            $optselectJContent[] = JHTML::_('select.option', 'created', JText::_('CREATED'));
            $optselectJContent[] = JHTML::_('select.option', 'created_by', JText::_('CREATED BY'));
            $optselectJContent[] = JHTML::_('select.option', 'modified', JText::_('MODIFIED'));
            $optselectJContent[] = JHTML::_('select.option', 'modified_by', JText::_('MODIFIED BY'));
            $optselectJContent[] = JHTML::_('select.option', 'publish_up', JText::_('PUBLISH UP'));
            $optselectJContent[] = JHTML::_('select.option', 'publish_down', JText::_('PUBLISH DOWN'));
            $optselectJContent[] = JHTML::_('select.option', 'access', JText::_('ACCESS'));
            $optselectJContent[] = JHTML::_('select.option', 'introtext', JText::_('INTROTEXT'));
            //$optselectJContent[] = JHTML::_('select.option', 'fulltext', JText::_('FULLTEXT'));

            $tmpflds = @$process['expfields'];
            $selectedexpflds = ($tmpflds) ? explode(',', $tmpflds) : '';
            $lists['joomlaContent'] = JHTML::_('select.genericlist', $optselectJContent, 'expfields[]', 'size="13" class="inputbox" multiple="multiple"', 'value', 'text', $selectedexpflds);
            
            //////expstate
            $optselectState         = array();
            $optselectState []      = JHTML::_('select.option', '1', JText::_('PUBLISHED'));
            $optselectState []      = JHTML::_('select.option', '0', JText::_('UNPUBLISHED'));
            $exp_state              = @$process['exp_state'];
            $selectExp_state        = ( @$exp_state ) ? $exp_state : '';
            $lists['exp_state']     = JHTML::_('select.genericlist', $optselectState, 'attributes[exp_state]', 'class="inputbox " size="1"', 'value', 'text', $selectExp_state);
            ///////

            ////

            // choose the cat, cat+sous-cat,or sous-cat only,

            $optselectJcats = array();
            $optselectJcats[] = JHTML::_('select.option', '', JText::_('SELECT OPTIONS'));
            $optselectJcats[] = JHTML::_('select.option', '3', JText::_('CATEGORY ONLY'));
            $optselectJcats[] = JHTML::_('select.option', '2', JText::_('CATEGORY AND SUB-CATEGORY'));
            $optselectJcats[] = JHTML::_('select.option', '1', JText::_('SUB-CATEGORIES ONLY'));
            $catandsubcat = @$process['catandsubcat'];
            $selectCatandsubcat = ( @$catandsubcat ) ? $catandsubcat : '';
            $lists['joomlaselectcats'] = JHTML::_('select.genericlist', $optselectJcats, 'attributes[catandsubcat]', 'size="1" class="inputbox required  " ', 'value', 'text', $selectCatandsubcat);




            //category and/or content type
            $optContentType1 = array();
            $optContentType1[] = JHTML::_('select.option', '', JText::_('SELECT A CONTENT TYPE'));
            $optContentType1 = array_merge($optContentType1, HelperjSeblod_Helper::getContentTypesByName(0));
            $exp_content_type = @$process['exp_content_type'];
            $selectExpContentType = (@exp_content_type) ? $exp_content_type : '';
            $lists['ctype1'] = JHTML::_('select.genericlist', $optContentType1, 'attributes[exp_content_type]', 'class="inputbox  " size="1"', 'value', 'text', $selectExpContentType);
           
            //type de field
            $optfieldType = array();
            //$optfieldType[]		=	JHTML::_('select.option', '', JText::_( 'SELECT A FIELD TYPE' ) );
            $optfieldType[] = JHTML::_('select.option', '1', JText::_('ALL FIELDS'));
            $optfieldType[] = JHTML::_('select.option', '3', JText::_('CUSTOM FIELDS'));
            $optfieldType[] = JHTML::_('select.option', '2', JText::_('CUSTOM SELECTION'));
            $expfields = @$process['field_type'];
            $selectExpfields = (isset($expfields)) ? $expfields : '';
            $lists['field_type'] = JHTML::_('select.genericlist', $optfieldType, 'attributes[field_type]', 'class="inputbox  " size="1"', 'value', 'text', $selectExpfields);

            //Joomla?
            $optJType = array();
            $optJType[] = JHTML::_('select.option', '1.5', JText::_('FOR_JOOMLA_15'));
            $optJType[] = JHTML::_('select.option', '1.7', JText::_('FOR_JOOMLA_17'));
            $selectJversion = (isset($process['joomla_version'])) ? $process['joomla_version'] : '1.5';
            $lists['j_type'] = JHTML::_('select.radiolist', $optJType, 'attributes[joomla_version]', 'class="inputbox"', 'value', 'text', $selectJversion);
         
            // Push Data to Template
            $this->assignRef('option', $option);
            $this->assignRef('controller', $controller);
            $this->assignRef('viewName', $this->_viewName);
            $this->assignRef('document', $document);
            $this->assignRef('doCopy', $doCopy);
            $this->assignRef('viewItem', $viewItem);
            $this->assignRef('isNew', $isNew);
            $this->assignRef('lists', $lists);
            $this->assignRef('modals', $modals);
            $this->assignRef('tooltips', $tooltips);
            $this->assignRef('taskname', $taskname);
            $this->assignRef('listsProcess', $listsProcess);
            $this->assignRef('langEnabled', $langEnabled);
            $this->assignRef('listsparams', $listsparams);
            $this->assignRef('configs', $configs);
            $this->assignRef('process', $process);
            $this->assignRef('viewTable', $this->_viewTable);
            $this->assignRef('viewTableJoin', $this->_viewTableJoin);


            $this->_displayToolbar($isNew, $doCopy, $isAuth, @$viewItem->id);
        }

        parent::display($tpl);
    }

}

?>