<?php
/**
* @version 			1.0.0
* @author       	http://www.seblod.com
* @copyright		Copyright (C) 2012 SEBLOD. All Rights Reserved.
* @license 			GNU General Public License version 2 or later; see _LICENSE.php
* @package			Tasks & WebServices for SEBLOD 1.x
**/
 
// No Direct Access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * View Class
 * */
class CCKjSeblod_WebServiceViewWebService extends JView {

    var $_viewName  = 'webservice';
    var $_viewNames = 'webservices';
    var $_viewTable = 'jseblod_cck_webservices';
    var $_viewTitle = 'ACCESS'; //WEBSERVICE
    var $_viewTitles= 'ACCESS'; //WEBSERVICES

    /**
     * Display Delete Toolbar
     * */

    function _displayDeleteToolbar() {
        JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . JText::_('Delete') . ' ]</small></small>', $this->_viewNames . '.png');
        JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Close'), false); //JToolBarHelper::cancel( 'cancel', 'Close' );
        JToolBarHelper::divider();
        Helper_Display::help($this->_viewNames);
    }

    /**
     * Display Toolbar
     * */
    function _displayToolbar($isNew, $doCopy, $isAuth) {
        if ($isAuth) {
            JToolBarHelper::custom('save', 'save_jseblod', 'save_jseblod', JText::_('Save'), false); //JToolBarHelper::save();
            JToolBarHelper::custom('apply', 'apply_jseblod', 'apply_jseblod', JText::_('Apply'), false); //JToolBarHelper::apply();;
            JToolBarHelper::spacer();
        }
        if ($isNew || $doCopy) {
            $text = $doCopy ? JText::_('Copy') : JText::_('New');
            JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . $text . ' ]</small></small>', $this->_viewNames . '.png');
            JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Cancel'), false); //JToolBarHelper::cancel();
        } else {
            $text = $isAuth ? JText::_('Edit') : JText::_('View');
            JToolBarHelper::title(JText::_($this->_viewTitle) . ': <small><small>[ ' . $text . ' ]</small></small>', $this->_viewNames . '.png');
            JToolBarHelper::custom('cancel', 'cancel_jseblod', 'cancel_jseblod', JText::_('Close'), false); //JToolBarHelper::cancel( 'cancel', 'Close' );
        }
        JToolBarHelper::divider();
        Helper_Display::help($this->_viewName);
    }

    /**
     * Display Default View
     * */
    function display($tpl = null) {
        // Get Request Vars
        global $mainframe, $option;
        $user = & JFactory::getUser();
        $controller = JRequest::getWord('controller');
        $document = & JFactory::getDocument();

        $doDelete = JRequest::getVar('doDelete', false);
        $isAuth = ( $user->get('gid') < _EDIT_ACCESS ) ? 0 : 1;

        if ($doDelete) {

            $removeItems = & $this->get('RemoveData');

            $this->assignRef('option', $option);
            $this->assignRef('controller', $controller);
            $this->assignRef('removeItems', $removeItems);

            $this->_displayDeleteToolbar();
        } else {

            jimport('joomla.filesystem.folder');

            // Get Data from Model
            $viewItem = & $this->get('Data');

            // Set Flags
            $isNew = ( @$viewItem->id > 0 ) ? 0 : 1;
            $doCopy = JRequest::getVar('doCopy', true);

            // Checking!
            if (JTable::isCheckedOut($user->get('id'), @$viewItem->checked_out)) {
                $msg = JText::sprintf('DESCBEINGEDITTED', '', $viewItem->title);
                $mainframe->redirect(_LINK_VIEW_1, $msg, 'notice');
            }

            // Set Wysiwyg Modal
            $modals['description'] = Helper_Display::quickModalWysiwyg('Description', $controller, 'description', 'pagebreak', 0, @$viewItem->id, false);
            $tooltips['link_description'] = Helper_Display::quickTooltipAjaxLink('Description', $controller, 'description', @$viewItem->id);

            // Set Published List ( Boolean List )
            $selectedPublished = ( $isNew ) ? 1 : $viewItem->published;
            $lists['published'] = JHTML::_('select.booleanlist', 'published', 'class="inputbox"', $selectedPublished);

            // Set Category List ( Select List )
            $optionCategories = array();
            $optionCategories[] = JHTML::_('select.option', '', JText::_('SELECT A CATEGORY'), 'value', 'text');
            $optionCategories[] = JHTML::_('select.option', '1', JText::_('QUICK CATEGORY'), 'value', 'text');
            $optionCategories[] = JHTML::_('select.option', '<OPTGROUP>', JText::_('Categories'));
            $optionCategories = (!$isNew && !$viewItem->categorystate ) ? array_merge($optionCategories, Helper_Helper::getViewCategories($this->_viewTable . '_categories', true, false)) : array_merge($optionCategories, Helper_Helper::getViewCategories($this->_viewTable . '_categories', true, true));
            $optionCategories[] = JHTML::_('select.option', '</OPTGROUP>', '');
            $selectFilterInCategory = ( JRequest::getInt('filter_search') == 5 ) ? JRequest::getInt('search') : '';
            $selectFilterCategory = ( $selectFilterInCategory || JRequest::getInt('filter_category') ) ? ( ( $selectFilterInCategory ) ? $selectFilterInCategory : JRequest::getInt('filter_category') ) : ( 1 );
            $selectedCategory = (!$isNew ) ? $viewItem->category : $selectFilterCategory;
            $lists['category'] = JHTML::_('select.genericlist', $optionCategories, 'category', 'class="inputbox required required-enabled" size="1"', 'value', 'text', $selectedCategory);

            $optType = array();
            $optType[] = JHTML::_('select.option', '', JText::_('SELECT A TYPE'));
            $optType[] = JHTML::_('select.option', 1, JText::_('SOAP + WSDL'));
            $optType[] = JHTML::_('select.option', 2, JText::_('HTTP'));
            $optType[] = JHTML::_('select.option', 3, JText::_('FTP'));
            $optType[] = JHTML::_('select.option', 4, JText::_('LOCAL'));
            $optType[] = JHTML::_('select.option', 5, JText::_('JOOMLA DATABASE'));   //export the contents
            //$optType[] = JHTML::_('select.option', 99, JText::_('BACKUP DATABASE'));

            $selectType = (!$isNew ) ? $viewItem->type : '';  //
            $lists['type'] = JHTML::_('select.genericlist', $optType, 'type', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectType);

            //radio , Get automatically last file
            $selectedLastFile = ( $isNew ) ? 1 : $viewItem->lastfile;
            $lists['get_lastfile'] = JHTML::_('select.booleanlist', 'lastfile', 'class="inputbox"', $selectedLastFile);


            $selectedLocalMode = ( $isNew ) ? 1 : $viewItem->localmode;
            $optionsLocalMode = array();
            $optionsLocalMode[] = JHTML::_('select.option', '1', 'Upload a file');
            $optionsLocalMode[] = JHTML::_('select.option', '2', 'Type Remote Address');
            $lists['get_local_mode']= JHTML::_('select.genericlist', $optionsLocalMode,  'localmode', 'class="inputbox"', 'value','text', $selectedLocalMode);


            $optGenerate = array();
            if (!$isNew) {
                $optGenerate[] = JHTML::_('select.option', 0, JText::_('NONE'));
            }
            $optGenerate[] = JHTML::_('select.option', 1, JText::_('FROM FILE UPLOAD'));
            $optGenerate[] = JHTML::_('select.option', 2, JText::_('FROM REMOTE URL'));
            $selectGenerate = (!$isNew ) ? 0 : 2;
            $lists['generate'] = JHTML::_('select.genericlist', $optGenerate, 'generate', 'size="1" class="inputbox required required-enabled"', 'value', 'text', $selectGenerate);

            // Push Data to Template
            $this->assignRef('option', $option);
            $this->assignRef('controller', $controller);
            $this->assignRef('document', $document);
            $this->assignRef('doCopy', $doCopy);
            $this->assignRef('viewItem', $viewItem);
            $this->assignRef('isNew', $isNew);
            $this->assignRef('lists', $lists);
            $this->assignRef('modals', $modals);
            $this->assignRef('tooltips', $tooltips);

            $this->_displayToolbar($isNew, $doCopy, $isAuth);
        }

        parent::display($tpl);
    }

}

?>